﻿if (typeof Design == "undefined") var Design = new Object();

Design.BottomFilletBlockMaster = function (param) {
    if (typeof param.pathForLeftCorner != "undefined") {
        this.PathForLeftCorner = param.pathForLeftCorner;
    }
    this.PositionForLeftCorner = "0 0";
    if (typeof param.positionForLeftCorner != "undefined") {
        this.PositionForLeftCorner = param.positionForLeftCorner;
    }
    if (typeof param.pathForRightCorner != "undefined") {
        this.PathForRightCorner = param.pathForRightCorner;
    }
    this.PositionForRightCorner = "0 0";
    if (typeof param.positionForRightCorner != "undefined") {
        this.PositionForRightCorner = param.positionForRightCorner;
    }
    if (typeof param.pathForLine != "undefined") {
        this.PathForLine = param.pathForLine;
    }
    this.PositionForLine = "0 0";
    if (typeof param.positionForLine != "undefined") {
        this.PositionForLine = param.positionForLine;
    }
    if (typeof param.pathForCorner != "undefined") {
        this.PathForCorner = param.pathForCorner;
    }
    this.PositionForCorner = "0 0";
    if (typeof param.positionForCorner != "undefined") {
        this.PositionForCorner = param.positionForCorner;
    }
    this.WidthLeftCorner = param.widthLeftCorner;
    this.WidthRightCorner = param.widthRightCorner;
    this.HeightLine = param.heightLine;
    this.WidthCorner = param.widthCorner;
    this.WidthCornerHalf = (this.WidthCorner / 2).toFixed();
    this.HeightCorner = param.heightCorner;
    this.ParentHolder = param.parentHolder;
    if (typeof param.leftPercent != "undefined") {
        this.LeftPercent = param.leftPercent;
    }
    else {
        this.LeftPercent = "50";
    }
    if (typeof param.rightPercent != "undefined") {
        this.RightPercent = param.rightPercent;
    }
    else {
        this.RightPercent = "50";
    }
    if (typeof param.idPrefix != "undefined") {
        this.IdPrefix = param.idPrefix;
    }
    this.CornerRightMargin = null;
    if (typeof (param.cornerRightMargin) != "undefined") {
        this.CornerRightMargin = param.cornerRightMargin;
    }

    this.Init();
};

Design.BottomFilletBlockMaster.prototype = {
    Init: function () {
        var parentDiv = document.createElement("DIV");
        parentDiv.style.cssText = "overflow: hidden;";

        var temp;
        if (this.CornerRightMargin) {
            temp = this.ParentHolder.style.display;
            this.ParentHolder.style.display = "block";
        }

        var divLeftLine = document.createElement("DIV");
        var width = this.CornerRightMargin ? (this.ParentHolder.offsetWidth - this.CornerRightMargin) + "px" : this.LeftPercent + "%";
        divLeftLine.style.cssText = "width: " + width + "; float: left; position: relative;";

        if (this.CornerRightMargin)
            this.ParentHolder.style.display = temp;

        var divLeftLineMain = document.createElement("DIV");
        var css_style = "margin-right: " + this.WidthCornerHalf + "px; margin-left: " + this.WidthLeftCorner + "px; height: " + this.HeightLine + "px; " +
                                        "position: relative;";
        if (this.PathForLine) {
            css_style = css_style + " background-position: " + this.PositionForLine + "; background-repeat: repeat-x;  background-image: url(" + this.PathForLine + "); ";
        }
        divLeftLineMain.style.cssText = css_style;
        divLeftLine.appendChild(divLeftLineMain);
        if (this.IdPrefix) {
            divLeftLineMain.id = this.IdPrefix + "_BottomLeftLine";
        }

        var divLeftLineCorner = document.createElement("DIV");
        css_style = "width: " + this.WidthLeftCorner + "px; height: " + this.HeightLine + "px; " +
                                        "position: absolute; top: 0; left: 0;";
        if (this.PathForLeftCorner) {
            css_style = css_style + " background-position: " + this.PositionForLeftCorner + "; background-repeat: no-repeat; background-image: url(" + this.PathForLeftCorner + "); ";
        }
        divLeftLineCorner.style.cssText = css_style;
        if (this.IdPrefix) {
            divLeftLineCorner.id = this.IdPrefix + "_BottomLeftLineCorner";
        }
        divLeftLine.appendChild(divLeftLineCorner);

        parentDiv.appendChild(divLeftLine);

        var divRightLine = document.createElement("DIV");
        var width = this.CornerRightMargin ? this.CornerRightMargin + "px" : this.RightPercent + "%";
        divRightLine.style.cssText = "width: " + width + "; float: right; margin-left: -" + this.WidthCornerHalf + "px; position: relative;";

        var divRightLineMain = document.createElement("DIV");
        css_style = "margin-left: " + this.WidthCornerHalf + "px; margin-right: " + this.WidthRightCorner + "px; height: " + this.HeightLine + "px; " +
                                          "position: relative;";
        if (this.PathForLine) {
            css_style = css_style + " background-repeat: repeat-x; background-position: " + this.PositionForLine + "; background-image: url(" + this.PathForLine + "); ";
        }
        divRightLineMain.style.cssText = css_style;
        if (this.IdPrefix) {
            divRightLineMain.id = this.IdPrefix + "_BottomRightLine";
        }
        divRightLine.appendChild(divRightLineMain);

        var divRightLineCorner = document.createElement("DIV");
        css_style = "width: " + this.WidthRightCorner + "px; height: " + this.HeightLine + "px; " +
                                        "position: absolute; top: 0; right: 0;";
        if (this.PathForRightCorner) {
            css_style = css_style + " background-position: " + this.PositionForRightCorner + "; background-repeat: no-repeat; background-image: url(" + this.PathForRightCorner + "); ";
        }
        divRightLineCorner.style.cssText = css_style;
        if (this.IdPrefix) {
            divRightLineCorner.id = this.IdPrefix + "_BottomRightLineCorner";
        }
        divRightLine.appendChild(divRightLineCorner);

        parentDiv.appendChild(divRightLine);

        var divCenterLine = document.createElement("DIV");
        css_style = "width: " + this.WidthCorner + "px; height: " + this.HeightCorner + "px; float: left; " +
                                    "margin-left: -" + this.WidthCornerHalf + "px; " +
                                    "position: relative;";
        if (this.PathForCorner) {
            css_style = css_style + " background-image: url(" + this.PathForCorner + "); background-position: " + this.PositionForCorner + "; background-repeat: no-repeat; ";
        }
        divCenterLine.style.cssText = css_style;
        if (this.IdPrefix) {
            divCenterLine.id = this.IdPrefix + "_BottomCenterLine";
        }
        parentDiv.appendChild(divCenterLine);

        this.ParentHolder.appendChild(parentDiv);
    }
};