﻿var passport;
/*паспорт*/
function Passport(params) {
    passport = this;

    var settings = $.extend({},
        {
            typeId: "NCI_DIRECTION", //тип набора данных
            dataKey: -1, //ключ набора данных
            holder: undefined, //контейнер для паспорта
            cubeId: "" //идентификатор куба для показателя
        }, params);

    if (settings.dataKey == -1 || settings.holder == undefined)
        return;

    //массив запросов аяксом
    var ajaxReqs = [];

    //получаем ключ набора по его идентификатору
    var data = { id: settings.dataKey };
    //запрос получения ключа направления по его идентификатору (в рабочем варианте должен идти синхронно перед всеми остальными запросами)
    ajaxReqs.push(
        $.ajax({
            type: "POST",
            url: "LoadData/Handlers/PassportService.asmx/GetKeyByID",
            contentType: "application/json; charset=utf-8",
            async: true,
            data: JSON.stringify(data),
            dataType: "json",
            success: function (json) {
                if (json != undefined && json != null && json != "") {
                    //здесь будет вызов основных функций паспорта
                }
            },
            error: function (a, b, c) {

            }
        })
    );


    var data = "?type=" + settings.typeId + "&key=" + settings.dataKey;
    this.Key = settings.dataKey;//ключ набора данных
    this.Type = settings.typeId;//тип набора данных
    this.PassportHolder = settings.holder;//контейнер для паспорта   
    this.Height = 0;//высота атрибутов паспорта
    this.IsRealData = false;//признак данных реального времени
    this.CubeId = settings.cubeId;//идентификатор куба для показателя

    //запрос информации о наборе данных
    ajaxReqs.push(
        $.ajax({
            type: "GET",
            url: "LoadData/Handlers/PassportHandler.ashx" + data,
            contentType: "application/json; charset=utf-8",
            async: true,
            dataType: "json",
            success: function (json) {
                if (json != undefined && json != null && json != "") {
                    passport.Json = json.info;
                    passport.IsRealData = json.meta.isRealData;
                    passport.OwnerKey = json.meta.ownerKey;
                    passport.OwnerName = json.meta.ownerName;
                    passport.OwnerPicture = json.meta.ownerPicture;
                    passport.Index = json.index;
                }
            },
            error: function (a, b, c) {
            }
        })
    );

    //запрос активности пользователя
    var data = { type: this.Type, key: this.Key };
    passport.MonitoringText = "";
    ajaxReqs.push(
        $.ajax({
            type: "POST",
            url: "LoadData/Handlers/PassportService.asmx/Monitoring",
            contentType: "application/json; charset=utf-8",
            async: true,
            data: JSON.stringify(data),
            dataType: "json",
            success: function (json) {
                if (json != undefined && json != null && json != "") {
                    passport.MonitoringText = json.d;
                }
            },
            error: function (a, b, c) {
                passport.MonitoringText = "";
            }
        })
    );


    $.when.apply($, ajaxReqs).then(function () {
        passport.CreatePassportInfo();
    });
};
/*пользовательская активность*/
Passport.prototype.UserMonitoring = function (callback) {
    //var data = "?type=" + settings.typeId + "&key=" + settings.dataKey;
    passport.MonitoringText = "";
    var data = { type: this.Type, key: this.Key };
    $.ajax({
        type: "POST",
        url: "LoadData/Handlers/PassportService.asmx/Monitoring",
        contentType: "application/json; charset=utf-8",
        async: true,
        data: JSON.stringify(data),
        dataType: "json",
        success: function (json) {
            if (json != undefined && json != null && json != "") {
                passport.MonitoringText = json.d;
                if (callback)
                    callback();
            }
        },
        error: function (a, b, c) {
            passport.MonitoringText = "";
        }
    });
}
/*описание паспорта*/
Passport.prototype.CreatePassportInfo = function () {
    this.CreateContainer();
    this.Height = 0;
    var table = $(document.createElement("table"));
    this.Container.append(table);
    for (var i = 0; i < this.Json.length; i++) {
        var attr = this.Json[i];
        if (attr.visible) {
            var elem = this.CreateElem(attr);
            table.append(elem);
            //this.Container.append(elem);
            this.Height += elem.height();
        }
    }
    if (this.Height <= 0)
        this.Height = 70;
    //создаем ссылку на загрузку паспорта
    var div = $(document.createElement("div"));
    div.addClass("elemPassport").css({ "position": "relative", "float": "right", "width": "120px" });
    var a = $(document.createElement("a"));
    var data = "?type=" + this.Type + "&key=" + this.Key + "&action=DOWNLOAD_PASP";

    var url = this.Type + "-" + this.Key + "/meta.csv";
    a.attr("href", url).html("Загрузить паспорт").addClass("hLinkPassport");//.css({ "color": "#3695f2", "border-bottom": "1px dashed #3695f2", "text-decoration": "none" });
    div.append(a);
    this.Container.append(div);

    this.ExportInfo(this.GetAttrById("FORMATS"));
    this.CreateEvents();
};
/*создает разметку для элемента*/
Passport.prototype.CreateElem = function (attr) {
    var tr = $(document.createElement("tr")).addClass("elemPassport");
    var tdName = $(document.createElement("td"));
    tdName.attr("width", "400");
    //var div = $(document.createElement("div"));
    //div = div.addClass("elemPassport");    
    var divName = $(document.createElement("div"));
    divName.addClass("namePassportAttr").html(attr.name + ":&nbsp;");
    tdName.append(divName);
    //div.append(divName);
    var divValue = $(document.createElement("div"));
    divValue = divValue.addClass("valuePassportAttr");
    var tdVal = $(document.createElement("td"));
    switch (attr.type) {
        case "STRING":
        case "DATETIME":
            //div.append(attr.value);            
            tdVal.append(attr.value);
            break;
        case "EMAIL":
            if (attr.value != "") {
                var link = $(document.createElement("a"));
                link = link.attr("href", "mailto:" + attr.value).html(attr.value);
            } else
                var link = "";
            divValue.append(link);
            //div.append(divValue);
            tdVal.append(divValue);
            break;
        case "URL":
            if (attr.value != "") {
                var link = $(document.createElement("a"));
                if (attr.key === 359264) {
                    //debugger;
                    //var fullDataHref = "LoadData/handlers/PassportHandler.ashx?action=getfile&url=" + encodeURI($(".valuePassportAttr a[href$='.CSV']").attr("href"));
                    link = link.attr("id", "url_359264").attr("href", attr.value).attr("target", "_blank").html(attr.value);
                } else {
                    if (attr.key === 359266) {
                        link = link.attr("href", attr.value).attr("target", "_blank").html(getFileName(attr.value));
                    } else {
                        link = link.attr("href", attr.value).html(attr.value);
                    }
                }
                if (attr.key === 359264) {
                    link.attr("href", attr.value + "/meta.csv").attr("target", "_blank");
                }
                divValue.css({ "text-overflow": "ellipsis", "overflow": "hidden"/*, "width": "600px"*/, "height": "20px", "white-space": "nowrap" });
            } else
                var link = "";
            divValue.append(link);
            //div.append(divValue);
            tdVal.append(divValue);
            break;
        case "XML":
            break;
        case "ARRAY":
            //div.append(attr.value.join(", "));
            tdVal.append(attr.value.join(", "));
            break;
        case "URL_ARRAY":
            if (attr.value.length > 0) {
                var h = 18 * attr.value.length;
                divValue.css({ "text-overflow": "ellipsis", "overflow": "hidden"/*, "width": "600px"*/, "height": h + "px", "white-space": "nowrap" });
                for (var i = 0; i < attr.value.length; i++) {
                    var val = attr.value[i];
                    if (val != "") {
                        var link = $(document.createElement("a"));
                        if (attr.key === 10 ||
                            attr.key === 359272 ||
                            attr.key === 359273 ||
                            attr.key === 359266) {
                            link = link.attr("href", val).attr("target", "_blank").html(getFileName(val));
                        } else {
                            link = link.attr("href", val).html(val);
                        }
                    } else
                        var link = "";
                    divValue.append(link);
                    divValue.append("<BR>");
                }
                //div.append(divValue);
                tdVal.append(divValue);
            }
            break;
    }
    tr.append(tdName).append(tdVal);
    if (attr.key === 10) tr.hide();
    return tr;//div;
};

// получаем имя файла из url
function getFileName(link) {
    link = link.split('/');
    //debugger;
    return link.length > 0 ? link[link.length - 1] : "";
}
/*задаем события для элементов паспорта*/
Passport.prototype.CreateEvents = function () {
    //$('.SERV_SearchResultPassport').bind('click', function (e) {
    $('div#showHidePassportInfo').bind('click', function (e) {
        e.stopPropagation();

        $('.SERV_SearchResultAdditional').slideToggle(230, function () {
            $(this).toggleClass('_show');

            var paspelems = $("tr.elemPassport");
            passport.Height = 20;
            for (var i = 0; i < paspelems.length; i++)
                passport.Height += $(paspelems[i]).outerHeight();

            var base_height = $('#ReestrHolder').height();
            var content_height = $('#contentCenter').height();
            var additional_height = $(this).outerHeight();
            if ($('#footerLister').length <= 0) {
                additional_height += 30;
            }
            if ($(this).hasClass('_show')) {
                var newHeight = additional_height + 10 + passport.Height;
                $('#ReestrHolder').height(base_height + newHeight);
                $('#contentCenter').height(content_height + newHeight);
                $(this).height(passport.Height);
                $(this).height($(".SERV_SearchResultAdditional table").height() + $(".SERV_SearchResultAdditional .elemPassport").height());

            } else {
                var height = additional_height + 10;
                $('#ReestrHolder').height(base_height - height);
                $('#contentCenter').height(content_height - height);
                $(this).height(0);
            }

        });
    });
    $('div#showHidePassportInfo').bind('click', function (e) {
        e.stopPropagation();
        $(this).toggleClass('hover');
    });

    $("div#showPassportLink").click(function () {
        //debugger;
        if ($("#showPassportLinkFirstCol") != undefined) {
            $("div#showPassportLink ul").width(200).css("top", 42).css("right", 1);
            $("#showPassportLinkFirstCol").slideToggle(200);
            $("#showPassportLinkSecondCol").slideToggle(200);
        }
        $(this).find("ul").slideToggle(200);
    });
};
/*создаем контейнер для паспорта*/
Passport.prototype.CreateContainer = function () {
    //this.PassportHolder.prepend('<div class="wrapperIndicator"><div style="float: left; width: 4px; padding: 0px; margin: 0px;" class="SERV_SearchResultItemCenterPartLL"></div>' +
    //   '<div style="float: right; width: 4px; padding: 0px; margin: 0px;" class="SERV_SearchResultItemCenterPartRL"></div>' +
    //   '<div style="margin: 0px; padding: 0px 0px 10px;" class="SERV_SearchResultItemCenterPartBC"><div class="SERV_SearchResultItemContent Only"><div class="SERV_SearchResultItemCaption Only">' +
    //   '<div class="SERV_SearchResultItemTxtCaptionFact Only paspCaption">' + this.GetAttrById("NAME") + '</div></div><div class="SERV_SearchResultItemSource Only"><div class="SERV_SearchResultItemSourceLink">' +
    //   //'<span>Владелец набора открытых данных:</span><div onclick="od.SearchManager.SearchAllSource(\'' + this.GetAttrById("OWNER") + '\');" onmouseover="$(this.parentNode).addClass(\'Hover\');" onmouseout="$(this.parentNode).removeClass(\'Hover\');" style="display: inline-block;">' + this.GetAttrById("OWNER") + '</div></div></div>' +
    //   //'<div class="SERV_SearchResultItemChangeDate Only">Дата последнего внесения изменений: ' + this.GetAttrById("LASTCHANGE_DATE") + '</div>' +
    //   //'<div class="SERV_SearchResultItemPublishDate Only">Дата публикации: ' + this.GetAttrById("START_DATE") + '</div>' +
    //   '<div class="SERV_SearchResultMonitoring" style="right:340px;top:-9px;">' + passport.MonitoringText + '</div>' +
    //   '<div class="SERV_SearchResultPassport hLinkPassport" style="right:-120px;">Паспорт набора данных</div>' +
    //   '<div class="SERV_SearchResultLoad hLinkPassport" style="right:-120px;">Загрузить набор данных<ul style="display: none;"></ul></div>' +
    //   '<div class="SERV_SearchResultAdditional"></div>' +       
    //   '</div></div></div>');

    //========главный слой========
    var mainDiv = $(document.createElement("div")).addClass("wrapperIndicator");

    //======верхняя линия шапки========
    var divTopLine = $(document.createElement("div"));
    divTopLine.addClass("paspTopLine");
    //направление
    var divOwner = $(document.createElement("div"));
    var divText = $(document.createElement("div"));
    divText.css({ "padding-left": "3px", "position": "relative", "float": "right" }).append(this.OwnerName);
    var img = $(document.createElement("img"));
    img.attr("src", "Images/APWidget/Hover/" + this.OwnerPicture).attr("width", "20px").attr("height", "20px");
    divOwner.addClass("paspOwner").append(img).append(divText);
    //дата последнего изменения
    var divUpd = $(document.createElement("div"));
    divUpd.addClass("paspOwner").append("Обновлено: " + this.GetAttrById("LASTCHANGE_DATE"));
    //мониторинг пользовательской активности
    var divMonitoring = $(document.createElement("div"));
    divMonitoring.addClass("paspMon").append(passport.MonitoringText);
    //ссылка на api
    var divApi = $(document.createElement("div"));
    divApi.addClass("paspApi").addClass("hLinkPassport").append("<a href='ForDevelopers/'>API</a>");
    //загрузить набор данных
    var divLoad = $(document.createElement("div"));
    divLoad.addClass("showPassport").addClass("load").addClass("hLinkPassport").append("Загрузить набор данных").attr("id", "showPassportLink");
    var ul = $(document.createElement("ul")).css({ "display": "none" });
    divLoad.append(ul);
    divTopLine.append(divOwner).append(divUpd).append(divLoad).append(divApi).append(divMonitoring);

    //========название набора данных========
    var divCaptionLine = $(document.createElement("div"));
    //divCaptionLine.addClass("paspCaption").append(passport.Index + ". " + this.GetAttrById("NAME"));
    divCaptionLine.addClass("paspCaption").append(this.GetAttrById("NAME"));

    //========нижняя линия шапки========
    var divBottomLine = $(document.createElement("div"));
    var div = $(document.createElement("div")).attr("id", "showHidePassportInfo");
    div.addClass("showPassport").addClass("show").addClass("hLinkPassport").append("Паспорт набора данных");

    var divLink = $(document.createElement("div")).attr("id", "infoUsageLink");
    divLink.addClass("showInfolink").addClass("showPassport").append("<a href ='http://data.gov.ru/information-usage' target='_blank' class='hLinkPassport'>Типовые условия использования</a>");

    divBottomLine.addClass("paspBottomLine").append(div).append(divLink);

    //========контейнер для паспорта========
    var divContainer = $(document.createElement("div"));
    divContainer.addClass("SERV_SearchResultAdditional");

    mainDiv.append(divTopLine).append(divCaptionLine).append(divBottomLine).append(divContainer);
    this.PassportHolder.prepend(mainDiv);
    this.Container = $("div.SERV_SearchResultAdditional");
};
/*получаем значение атрибута по ИД*/
Passport.prototype.GetAttrById = function (id) {
    if (this.Json == undefined)
        return "";
    for (var i = 0; i < this.Json.length; i++) {
        var elem = this.Json[i];
        if (elem.id == id.toUpperCase())
            return elem.value;
    }
};
/*форматы экспорта данных*/
Passport.prototype.ExportInfo = function (formats) {
    if (formats == undefined)
        return;

    //var ul = $("div.SERV_SearchResultLoad").find("ul");    
    var ul = $("div#showPassportLink").find("ul");
    for (var i = 0; i < formats.length; i++) {
        var format = formats[i];
        var input = $(document.createElement("input"));
        var li = $(document.createElement("li"));
        input.attr("type", "button").attr("id", "outerExport" + format).addClass("exportButton")
            .attr("data-type", "export").attr("value", format).data("cubeID", this.CubeId);

        switch (this.Type) {
            case "NCI_DIRECTIONS":
            case "NCI_DIRECTIONS_RD":
                input.click(function () {
                    var key = passport.Key;
                    var isRealData = passport.IsRealData;
                    var format = $(this).attr("value");
                    if (format != "RDF") {
                        if (isRealData == true)
                            document.location.href = "LoadData/handlers/RealTimeDataHandler.ashx?direction=" + key + "&format=" + format + "&action=exportfile";
                        else
                            document.location.href = "LoadData/SerializedHandler.ashx?direction=" + key + "&format=" + format + "&action=exportfile";
                    }
                    else {
                        var url = "http://openhack.permkrai.ru/linkeddata/reestr/reestr" + key + ".ttl.zip";
                        //var url = "http://" + window.location.host + "/linkeddata/reestr/reestr" + key + ".ttl.zip";
                        passport.GetRDF(url);
                    }
                });
                break;
            case "KSP":
                input.click(function () {
                    var key = passport.Key;
                    var format = $(this).attr("value");
                    var isXml = format == "XML" ? "1" : "0";
                    var cube = $(this).data("cubeID");
                    if (format != "RDF") {
                        var exporter = new iascore.FileDownloader(od.pageCorrector + "Handlers/HCdsFactorLoad.ashx?factor=" + key + "&cube=" + cube + "&isXML=" + isXml);
                    } else {
                        //var url = "http://" + window.location.host + "/linkeddata/data/cube" + cube + ".ttl.zip";
                        var url = "http://openhack.permkrai.ru/linkeddata/data/cube" + key + ".ttl.zip";
                        passport.GetRDF(url);
                    }
                    exporter.Download();
                });
                break;
        }
        li.append(input);
        ul.append(li);
    }
    if (this.Type == "NCI_DIRECTIONS") {
        $("#showPassportLink").html("Загрузить набор данных <div id='showPassportLinkFirstCol'><ul>" + ul.html() + "</ul></div><div id='showPassportLinkSecondCol'><ul>" + ul.html() + "</ul></div>");
        $("#showPassportLinkFirstCol").prepend("<div class='showPassportLinkHeader'>Ознакомительная версия набора (первые 100 строк)</div>");
        $("#showPassportLinkSecondCol").prepend("<div class='showPassportLinkHeader2'>Полный набор данных (обновляемый еженедельно)</div>");
        $("#showPassportLinkSecondCol ul li input").each(function () {
            this.id = this.id + "Full";
        });
        $("#showPassportLink input").each(function () {

            $(this).click(function () {
                var key = passport.Key;
                var isRealData = passport.IsRealData;
                var format = $(this).attr("value");
                if (format != "RDF") {
                    if (this.id.indexOf("Full") > -1) {
                        if ($(".valuePassportAttr a[href$='." + format + "']").attr("href") == undefined) {
                            window.AlertWindow.show("Архив недоступен", "Файл архива еще не сформирован, используйте другие форматы данных.");
                        } else {
                            document.location.href = "LoadData/handlers/PassportHandler.ashx?action=getfile&url=" + encodeURI($(".valuePassportAttr a[href$='." + format + "']").attr("href"));
                        }
                        //debugger;
                        //var exporter = new iascore.FileDownloader(decodeURI( $(".valuePassportAttr a[href$='." + format + "']").attr("href")));
                        //exporter.DownloadNoToken();
                        //var fileUrl = $(".valuePassportAttr a[href$='." + format + "']");
                        //if (fileUrl.length > 0) fileUrl[0].click();
                        // debugger;
                    } else {
                        //debugger;
                        if (isRealData == true)
                            document.location.href = "LoadData/handlers/RealTimeDataHandler.ashx?direction=" + key + "&format=" + format + "&action=exportfile";
                        else
                            document.location.href = "LoadData/SerializedHandler.ashx?direction=" + key + "&format=" + format + "&action=exportfile";
                    }
                }
                else {
                    if (this.id.indexOf("Full") > -1) {
                        if ($(".valuePassportAttr a[href$='." + format + "']").attr("href") == undefined) {
                            window.AlertWindow.show("Архив недоступен", "Файл архива еще не сформирован, используйте другие форматы данных.");
                        } else {
                            document.location.href = "LoadData/handlers/PassportHandler.ashx?action=getfile&url=" + encodeURI($(".valuePassportAttr a[href$='." + format + "']").attr("href"));
                        }
                    } else {
                        var url = "http://openhack.permkrai.ru/linkeddata/reestr/reestr" + key + ".ttl.zip";
                        //var url = "http://" + window.location.host + "/linkeddata/reestr/reestr" + key + ".ttl.zip";
                        //debugger;
                        passport.GetRDF(url);
                    }
                }
            });
        });

        if ($(".valuePassportAttr a[href$='.CSV']").attr("href") != undefined) {
            $("#url_359264").attr("href", "LoadData/handlers/PassportHandler.ashx?action=getfile&url=" + encodeURI($(".valuePassportAttr a[href$='.CSV']").attr("href")));
        }


        /*
        ul.find("li").each(function () {
            // добавляем ссылки на сохраненные полные версии данных
            var input = $($(this).find("input")[0]).addClass("exportButtonHalf");
            var inputFull = $(document.createElement("input"));
            inputFull.attr("type", "button").attr("id", input.attr("id") + "Full").addClass("exportButton").addClass("exportButtonHalf")
            .attr("data-type", "export").attr("value", input.attr("value")).data("cubeID", this.CubeId);
            //inputFull.id = inputFull.id + "Full";
            $(this).append(inputFull);
            //debugger;
        });
        debugger;
        ul.prepend("<li><span>Ознакомительная версия набора (первые 100 строк)</span><span>Полный набор данных (обновляемый еженедельно)</span></li>");
        */
    }

};
//получает zip-архив

Passport.prototype.GetRDF = function (url) {
    document.location.href = url;
};

/*
Passport.prototype.GetRDF = function (url) {
    var xhr = new XMLHttpRequest();
    xhr.onreadystatechange = function () {
        debugger;
        switch (this.readyState) {
            
            case 0: // UNINITIALIZED
            case 1: // LOADING
            case 2: // LOADED
            case 3: // INTERACTIVE
                break;
            case 4: // COMPLETED
                if (this.status == 200) {
                    var wnd = window.open(url);
                } else {
                    window.AlertWindow.show("Архив недоступен", "Файл архива еще не сформирован, используйте другие форматы данных.");
                }
                break;
            default: window.AlertWindow.show("Архив недоступен", "Файл архива еще не сформирован, используйте другие форматы данных.");
        }
    };
    xhr.open("GET", url, true);
}*/