﻿if (typeof od.searchengine == "undefined") od.searchengine = new Object();

od.searchengine.ResultsFilter =
{
    All: 0,
    Facts: 1,
    Documents: 2,
    Polls: 4,
    Proposals: 5,
    None: 6
};

od.searchengine.AdvancedFilterFavoriteElement =
{
    All: 0,
    Favorite: 1
};

od.searchengine.AdvancedFilterCommentElement =
{
    All: 0,
    Comment: 1
};

od.searchengine.SortOption =
{
    Relevance: 0,
    Rating: 1,
    Date: 2,
    CDate: 3,
    EName: 4,
	DataCount: 5
};

od.searchengine.SortOptionDop =
{
    Relevance: 0,
    Doc: 1,
    Fact: 2
};

od.searchengine.SearchOption = {
    Simple: 0,
    Extended: 1,
    Source: 2
};

od.searchengine.DateOption = {
    All: "ALL",
    New: "NEW",
    LastWeek: "LAST_WEEK",
    LastMonth: "LAST_MONTH",
    Date: "PICKER_DATE"
};

//БАЗОВЫЙ КЛАСС, В КОТОРОМ ВИЗУАЛ ОТДЕЛЁН ОТ САМОГО МЕХАНИЗМА ПОИСКА
//но в него не стала добавлять пока строку поиска, так как она берётся\кладётся прямо в контрол, то есть он ищет всегда по пустой строке

od.searchengine.SearchBarBase = function () {
    this.ResultsViewer = null;

    this.IsFindCallback = new Array();

    this.ResultsFilterOptionAll = null;
    this.ResultsFilterOptionDocs = null;
    this.ResultsFilterOptionFacts = null;
    this.ResultsFilterValue = od.searchengine.ResultsFilter.All;

    this.SortOptionRelevance = null;
    this.SortOptionRating = null;
    this.SortOptionDate = null;
    this.SortOptionValue = od.searchengine.SortOption.Date;//.Relevance;

    this.SortOptionDopValue = od.searchengine.SortOptionDop.Fact;//.Relevance;

    this.SearchOptionExtended = null;
    this.SearchOptionSimple = null;
    this.SearchOptionSource = null;
    this.SearchOptionValue = od.searchengine.SearchOption.Extended;

    this.AdvancedFilterFavoriteValue = od.searchengine.AdvancedFilterFavoriteElement.All;
    this.AdvancedFilterCommentValue = od.searchengine.AdvancedFilterCommentElement.All;
    this.AdvancedFilterFavoriteCheckBox = null;
    this.AdvancedFilterCommentCheckBox = null;

    this._dateOptionAll = null;
    //this._dateOptionNew = null;
    this._dateOptionWeek = null;
    this._dateOptionMonth = null;
    this._dateOptionDatePicker = null;
    this.DateOptionValue = od.searchengine.DateOption.All;

    this.DirectionOptionValue = "-1";
    this.FromMainOptionValue = false;
};

var searchBarBaseP = od.searchengine.SearchBarBase.prototype;

searchBarBaseP.CreateResultViewer = function (resultsHolderID,
                                            pageSelectorHolderID,
                                            resultsStatsHolderID) {
    this._resultsHolderID = null;
    this._pageSelectorHolderID = null;
    this._resultsStatsHolderID = null;
    this._resultsSortHolderID = null;

    if (typeof resultsHolderID != "undefined" && resultsHolderID) {
        this._resultsHolderID = resultsHolderID;
    }

    if (typeof pageSelectorHolderID != "undefined" && pageSelectorHolderID) {
        this._pageSelectorHolderID = pageSelectorHolderID;
    }

    if (typeof resultsStatsHolderID != "undefined" && resultsStatsHolderID) {
        this._resultsStatsHolderID = resultsStatsHolderID;
    }

    this.ResultsViewer = new od.searchengine.ResultsViewer(this._resultsHolderID, this._pageSelectorHolderID, this._resultsStatsHolderID, this._sortHolderID, this);
};

searchBarBaseP.StartSearchBase = function (saveRequest, txtForFind, topCnt, callback) {
    //debugger;
    var findstr = txtForFind;
    if (txtForFind) {
        findstr = findstr.replace(/'/g, '');
    }
    else {
        findstr = "";
    }

    if (this.ResultsViewer != null) {
        this.ResultsViewer.FindString = findstr;
        this.ResultsViewer.StartSearch(saveRequest, topCnt, callback);
    }
    else {
        AlertWindow.show("Ошибка", 'При запросе данных произошла ошибка. Пожалуйста, обратитесь к администратору.');
    }
};

searchBarBaseP.StartSearch = function (saveRequest, topCnt, txtForFind, callback) {
    //debugger;
    txtForFind = txtForFind == undefined ? "" : txtForFind;
    this.StartSearchBase(saveRequest, txtForFind, topCnt, callback);
};

searchBarBaseP.SetResultsFilterValue = function (value) {
    this.SetResultsFilterValueUI(value);
    if (this.ResultsViewer.ResultsHolder) {
        iascore.StartProgress();
        this.StartSearch(false);
    }
};

searchBarBaseP.SetResultsFilterValueUI = function (value) {
    this.ResultsFilterValue = value;
    if (this.ResultsViewer) {
        this.ResultsViewer.ResultsFilterValue = value;
    }
};

searchBarBaseP.SetSortOptionValue = function (value) {
    this.SetSortOptionValueUI(value);
    if (this.ResultsViewer.ResultsHolder) {
        this.StartSearch(false);
    }
};

searchBarBaseP.SetSortOptionValueUI = function (value) {
    this.SortOptionValue = value;
    if (this.ResultsViewer) {
        this.ResultsViewer.SortOptionValue = value;
    }
};

searchBarBaseP.SetSortOptionDopValue = function (value) {
    this.SetSortOptionDopValueUI(value);
    if (this.ResultsViewer.ResultsHolder) {
        this.StartSearch(false);
    }
};

searchBarBaseP.SetSortOptionDopValueUI = function (value) {
    this.SortOptionDopValue = value;
    if (this.ResultsViewer) {
        this.ResultsViewer.SortOptionDopValue = value;
    }

    if (this._comboSortParam)
    {
        this._comboSortParam.ComboBox.getTreeList().getNodeByIndex(this.SortOptionDopValue).setSelected(true);
        this._comboSortParam.ComboBox.setContent(this._comboSortParam.ComboBox.getTreeList()._SelectedNode.Text);
    }
};

searchBarBaseP.SetSearchOptionValue = function (value) {
    this.SetSearchOptionValueUI(value);
    if (this.ResultsViewer.ResultsHolder) {
        this.StartSearch(false);
    }
};

searchBarBaseP.SetSearchOptionValueUI = function (value) {
    this.SearchOptionValue = value;
    if (this.ResultsViewer) {
        this.ResultsViewer.SearchOptionValue = value;
    }
};

searchBarBaseP.SetAdvancedFilterValue = function (favoriteValue, commentValue) {
    this.SetAdvancedFilterValueUI(favoriteValue, commentValue);
    if (this.ResultsViewer.ResultsHolder) {
        this.StartSearch(false);
    }
};

searchBarBaseP.SetAdvancedFilterValueUI = function (favoriteValue, commentValue) {
    this.AdvancedFilterFavoriteValue = favoriteValue;
    this.AdvancedFilterCommentValue = commentValue;
    if (this.ResultsViewer) {
        this.ResultsViewer.AdvancedFilterFavoriteElementValue = favoriteValue;
        this.ResultsViewer.AdvancedFilterCommentElementValue = commentValue;
    }
};

searchBarBaseP.SetText = function (text) {
};

searchBarBaseP.SearchAllFavourites = function () {
    this.SetResultsFilterValueUI(od.searchengine.ResultsFilter.All);
    this.SetAdvancedFilterValueUI(od.searchengine.AdvancedFilterFavoriteElement.Favorite, od.searchengine.AdvancedFilterCommentElement.All);
    this.SetText("");
    this.SetDateOptionValueUI(od.searchengine.DateOption.All);
    this.SetSearchOptionValueUI(od.searchengine.SearchOption.Extended);
    //this.SetSortOptionValueUI(od.searchengine.SortOption.Relevance);
    this.SetSortOptionValueUI(od.searchengine.SortOption.Date);
    this.SetSortOptionDopValueUI(od.searchengine.SortOptionDop.Relevance);
    this.StartSearch(true);
};

searchBarBaseP.SearchAllComments = function () {
    this.SetResultsFilterValueUI(od.searchengine.ResultsFilter.All);
    this.SetAdvancedFilterValueUI(od.searchengine.AdvancedFilterFavoriteElement.All, od.searchengine.AdvancedFilterCommentElement.Comment);
    this.SetText("");
    this.SetDateOptionValueUI(od.searchengine.DateOption.All);
    this.SetSearchOptionValueUI(od.searchengine.SearchOption.Extended);
    //this.SetSortOptionValueUI(od.searchengine.SortOption.Relevance);
    this.SetSortOptionValueUI(od.searchengine.SortOption.Date);
    this.SetSortOptionDopValueUI(od.searchengine.SortOptionDop.Relevance);
    this.StartSearch(true);
};

searchBarBaseP.SearchAllFactors = function () {
    iascore.StartProgress();
    this.SetResultsFilterValueUI(od.searchengine.ResultsFilter.Facts);
    this.SetAdvancedFilterValueUI(od.searchengine.AdvancedFilterFavoriteElement.All, od.searchengine.AdvancedFilterCommentElement.All);
    this.SetText("");
    this.SetDateOptionValueUI(od.searchengine.DateOption.All);
    this.SetSearchOptionValueUI(od.searchengine.SearchOption.Extended);
    //this.SetSortOptionValueUI(od.searchengine.SortOption.Relevance);
    this.SetSortOptionValueUI(od.searchengine.SortOption.Date);
    this.SetSortOptionDopValueUI(od.searchengine.SortOptionDop.Relevance);
    this.StartSearch(true);
};

searchBarBaseP.SearchAllDocuments = function () {
    iascore.StartProgress();
    this.SetResultsFilterValueUI(od.searchengine.ResultsFilter.Documents);
    this.SetAdvancedFilterValueUI(od.searchengine.AdvancedFilterFavoriteElement.All, od.searchengine.AdvancedFilterCommentElement.All);
    this.SetText("");
    this.SetDateOptionValueUI(od.searchengine.DateOption.All);
    this.SetSearchOptionValueUI(od.searchengine.SearchOption.Extended);
    //this.SetSortOptionValueUI(od.searchengine.SortOption.Relevance);
    this.SetSortOptionValueUI(od.searchengine.SortOption.Date);
    this.SetSortOptionDopValueUI(od.searchengine.SortOptionDop.Relevance);
    this.StartSearch(true);
};

searchBarBaseP.SearchOtherAllElements = function (resultF, dateO, sortO) {
    this.SetResultsFilterValueUI(resultF);
    this.SetAdvancedFilterValueUI(od.searchengine.AdvancedFilterFavoriteElement.All, od.searchengine.AdvancedFilterCommentElement.All);
    this.SetText("");
    this.SetDateOptionValueUI(dateO);
    this.SetSearchOptionValueUI(od.searchengine.SearchOption.Extended);
    this.SetSortOptionValueUI(sortO);
    this.SetSortOptionDopValueUI(od.searchengine.SortOptionDop.Relevance);
    this.StartSearch(true);
};

searchBarBaseP.SearchAllSource = function (searchString) {
    iascore.StartProgress();
    this.SetResultsFilterValueUI(od.searchengine.ResultsFilter.All);
    this.SetAdvancedFilterValueUI(od.searchengine.AdvancedFilterFavoriteElement.All, od.searchengine.AdvancedFilterCommentElement.All);
    //this.SetText(searchString);
    $.cookie("ownerId", searchString);//записываем в куки ключ выбранного владельца
    this.SetDateOptionValueUI(od.searchengine.DateOption.All);
    this.SetSearchOptionValueUI(od.searchengine.SearchOption.Source);
    //this.SetSortOptionValueUI(od.searchengine.SortOption.Relevance);
    this.SetSortOptionValueUI(od.searchengine.SortOption.Date);
    this.SetSortOptionDopValueUI(od.searchengine.SortOptionDop.Relevance);
    this.StartSearch(true);
};

searchBarBaseP.SearchAllForProjects = function () {
    iascore.StartProgress();
    this.SetResultsFilterValueUI(od.searchengine.ResultsFilter.Documents);
    this.SetAdvancedFilterValueUI(od.searchengine.AdvancedFilterFavoriteElement.All, od.searchengine.AdvancedFilterCommentElement.All);
    this.SetText("ИАС УП");
    this.SetDateOptionValueUI(od.searchengine.DateOption.All);
    this.SetSearchOptionValueUI(od.searchengine.SearchOption.Extended);
    //this.SetSortOptionValueUI(od.searchengine.SortOption.Relevance);
    this.SetSortOptionValueUI(od.searchengine.SortOption.Date);
    this.SetSortOptionDopValueUI(od.searchengine.SortOptionDop.Relevance);
    this.StartSearch(true);
};

searchBarBaseP.SetDateOptionValue = function (value) {
    this.SetDateOptionValueUI(value);
    if (this.ResultsViewer.ResultsHolder) {
        this.StartSearch(false);
    }
};

searchBarBaseP.SetDateOptionValueUI = function (value) {
    this.DateOptionValue = value;
    if (this.ResultsViewer) {
        this.ResultsViewer.DateSelectorValue = value;
    }
};

searchBarBaseP.SetDirectionOptionValueUI = function (value) {
    this.DirectionOptionValue = value;
    if (this.ResultsViewer) {
        this.ResultsViewer.DirectionID = value;
    }
};
searchBarBaseP.SetOwnerIogvOptionValueUI = function (value) {
    this.OwnerKeyOptionValue = value;
    if (this.ResultsViewer) {
        this.ResultsViewer.OwnerKey = value;
    }
};
searchBarBaseP.SetFindStrOptionValueUI = function (value) {
    this.FindString = value;
    if (this.ResultsViewer) {
        this.ResultsViewer.FindString = value;
    }
};



searchBarBaseP.SetFromMainOptionValueUI = function (value) {
    this.FromMainOptionValue = value;
    if (this.ResultsViewer) {
        this.ResultsViewer.fromMain = value;
    }
};

searchBarBaseP.getCaseForFactor = function (_cnt) {
    var factCaption = "";
    var factCountStr = _cnt;
    var factCountSuffix = factCountStr.length >= 2
                        ? parseInt(factCountStr.substr(factCountStr.length - 2, 2))
                        : parseInt(factCountStr.substr(factCountStr.length - 1, 1));

    if (factCountSuffix >= 10 && factCountSuffix <= 20) {
        factCaption = "наборов данных";
    }
    else {
        factCountSuffix = parseInt(factCountStr.substr(factCountStr.length - 1, 1));
        switch (factCountSuffix) {
            case 1:
                factCaption = "набор данных";
                break;
            case 2:
            case 3:
            case 4:
                factCaption = "набора данных";
                break;
            default:
                factCaption = "наборов данных";
                break;

        }
    }

    return factCaption;
};

searchBarBaseP = null;

od.searchengine.SearchBarJS = function (parentNode,
                                        instanceName,
                                        resultsHolderID,
                                        pageSelectorHolderID,
                                        resultsStatsHolderID,
                                        sortHolderID,
                                        needShowResultsFilter,
                                        needShowSortOptions,
                                        needShowSearchOptions,
                                        needShowDateOptions,
                                        v_countDocument, //общее количетсво документов
                                        v_countFactor, //общее количество показателей
                                        statsHolderID, //элемент, куда будет выводиться статистика поиска. Если не задано, то стастистика не выводится
                                        needShowAdvancedFilter,
                                        showShortView) {

    od.searchengine.SearchBarJS.base.constructor.call(this);

    this.CurrentDelayID;
    this._parentNode = parentNode;
    this.InstanceName = instanceName;
    this._textBoxID = instanceName + "_txtFind";
    this._dropDownID = instanceName + "_txtFindDropDown";
    this._dropDownIDDisplayParent = instanceName + "_txtFindDropDownDisplayParent";
    this._statsHolderID = statsHolderID;
    this._sortHolderID = sortHolderID;
    this._statsAndFilterParamHolderID = instanceName + "_StatsAndFilterParam";
    this._docFilterParamHolderID = instanceName + "_DocFilterParam";
    this._factorFilterParamHolderID = instanceName + "_FactorFilterParam";
    this._resultsFilterHolderID = instanceName + "_resultsFilter";
    this._sortOptionsHolderID = instanceName + "_sortOptions";
    this._searchOptionsHolderID = instanceName + "_searchOption";
    this._advancedFilterHolderID = instanceName + "_advancedFilter";
    this._searchButtonsHolderID = instanceName + "_searchButtons";
    this._userHistoryLinkID = instanceName + "_historyLink";
    this._advancedLinkID = instanceName + "_advancedLink";
    this._sideLinksHolderID = instanceName + "_sideLinksHolder";
    this._awContentID = instanceName + "_advancedWindowContent";
    this._dateOptionsHolderID = instanceName + "_dateOptions";
    this._showShortView = showShortView;
    this._comboSortParam = null;

    this.OldText = '';
    if (v_countDocument) {
        this._countDocument = v_countDocument;
    }
    else {
        this._countDocument = "0";
    }

    if (v_countFactor) {
        this._countFactor = v_countFactor;
    }
    else {
        this._countFactor = "0";
    }

    this._advancedLink = null;
    this._sideLinksHolder = null;

    this._filterParamDocument = null;
    this._filterParamFactor = null;

    this._needShowResultsFilter = false;

    this._needShowSortOptions = typeof needShowSortOptions != "undefined"
        ? needShowSortOptions
        : true;
    this._needShowSearchOptions = typeof needShowSearchOptions != "undefined"
        ? needShowSearchOptions
        : true;
    this._needShowDateOptions = typeof needShowDateOptions != "undefined"
        ? needShowDateOptions
        : true;
    this._needShowAdvancedFilter = typeof needShowAdvancedFilter != "undefined"
        ? needShowAdvancedFilter
        : true;

    this._advancedWindow = null;
    this._awContent = null;

    this._render();

    this._InitBaseFunction(
        instanceName,
        null,
        this._textBoxID,
        this._dropDownID,
        this._dropDownIDDisplayParent,
        this._statsHolderID,
        this._sortHolderID,
        this._resultsFilterHolderID,
        this._sortOptionsHolderID,
        this._searchOptionsHolderID,
        this._userHistoryLinkID,
        this._advancedFilterHolderID,
        this._dateOptionsHolderID);

    if (this.ResultsFilterHolder) {
        this.ResultsFilterHolder.style.marginBottom = "8px";
    }

    this.SearchButtonsHolder = document.getElementById(this._searchButtonsHolderID);
    if (this.SearchButtonsHolder) {
        this.SearchButtonsHolder.style.marginBottom = "11px";

        var self = this;
        var StartSearchBtn = new PP.Ui.Button({
            ParentNode: this.SearchButtonsHolder,
            Width: 92,
            Content: "Найти",
            Click: function () {
                iascore.StartProgress();
                self._advancedWindow.hide();
                self._saveTempObjForSearchParams();
                self.StartSearch(false);
            },
            Style: "padding-left: 137px;"
        });
        StartSearchBtn.addClass("BluePPButton");
        StartSearchBtn.addClass("Find");

        var CancelSearchBtn = new PP.Ui.Button({
            ParentNode: this.SearchButtonsHolder,
            Width: 117,
            Content: "Отменить",
            Click: function () {
                self._clearTempObjForSearchParams();
                self._advancedWindow.hide();
            },
            Style: "padding-left: 8px;"
        });
        CancelSearchBtn.addClass("BluePPButton");
        CancelSearchBtn.addClass("Find");
    }

    this.CreateResultViewer(resultsHolderID, pageSelectorHolderID, resultsStatsHolderID);

    this._clearTempObjForSearchParams();
};

PP.initClass(od.searchengine.SearchBarJS, od.searchengine.SearchBarBase, "od.searchengine.SearchBarJS");

var searchBarJSP = od.searchengine.SearchBarJS.prototype;

searchBarJSP._clearTempObjForSearchParams = function () {
    this.tempObjForSearchParams =
    {
        ResultsFilterValue: null,
        SortOptionValue: null,
        SearchOptionValue: null,
        AdvancedFilterFavoriteValue: null,
        AdvancedFilterCommentValue: null,
        DateOptionValue: null
    };
};

searchBarJSP._setVisualForTempResultsFilterValue = function () {
    switch (this.tempObjForSearchParams.ResultsFilterValue) {
        case od.searchengine.ResultsFilter.All:
            if (this.ResultsFilterOptionAll) {
                this.ResultsFilterOptionAll.SetActivityState(iascore.PanelButtonState.Selected);
            }
            if (this.ResultsFilterOptionDocs) {
                this.ResultsFilterOptionDocs.SetActivityState(iascore.PanelButtonState.Active);
            }
            if (this.ResultsFilterOptionFacts) {
                this.ResultsFilterOptionFacts.SetActivityState(iascore.PanelButtonState.Active);
            }
            break;
        case od.searchengine.ResultsFilter.Documents:
            if (this.ResultsFilterOptionAll) {
                this.ResultsFilterOptionAll.SetActivityState(iascore.PanelButtonState.Active);
            }
            if (this.ResultsFilterOptionDocs) {
                this.ResultsFilterOptionDocs.SetActivityState(iascore.PanelButtonState.Selected);
            }
            if (this.ResultsFilterOptionFacts) {
                this.ResultsFilterOptionFacts.SetActivityState(iascore.PanelButtonState.Active);
            }
            break;
        case od.searchengine.ResultsFilter.Facts:
            if (this.ResultsFilterOptionAll) {
                this.ResultsFilterOptionAll.SetActivityState(iascore.PanelButtonState.Active);
            }
            if (this.ResultsFilterOptionDocs) {
                this.ResultsFilterOptionDocs.SetActivityState(iascore.PanelButtonState.Active);
            }
            if (this.ResultsFilterOptionFacts) {
                this.ResultsFilterOptionFacts.SetActivityState(iascore.PanelButtonState.Selected);
            }
            break;
        case od.searchengine.ResultsFilter.None:
            if (this.ResultsFilterOptionAll) {
                this.ResultsFilterOptionAll.SetActivityState(iascore.PanelButtonState.Active);
            }
            if (this.ResultsFilterOptionDocs) {
                this.ResultsFilterOptionDocs.SetActivityState(iascore.PanelButtonState.Active);
            }
            if (this.ResultsFilterOptionFacts) {
                this.ResultsFilterOptionFacts.SetActivityState(iascore.PanelButtonState.Active);
            }
            break;
    };
};

searchBarJSP._setVisualForTempSearchOptionValue = function () {
    switch (this.tempObjForSearchParams.SearchOptionValue) {
        case od.searchengine.SearchOption.Extended:
            if (this.SearchOptionExtended) {
                this.SearchOptionExtended.SetActivityState(iascore.PanelButtonState.Selected);
            }
            if (this.SearchOptionSimple) {
                this.SearchOptionSimple.SetActivityState(iascore.PanelButtonState.Active);
            }
            if (this.SearchOptionSource) {
                this.SearchOptionSource.SetActivityState(iascore.PanelButtonState.Active);
            }
            break;
        case od.searchengine.SearchOption.Simple:
            if (this.SearchOptionExtended) {
                this.SearchOptionExtended.SetActivityState(iascore.PanelButtonState.Active);
            }
            if (this.SearchOptionSimple) {
                this.SearchOptionSimple.SetActivityState(iascore.PanelButtonState.Selected);
            }
            if (this.SearchOptionSource) {
                this.SearchOptionSource.SetActivityState(iascore.PanelButtonState.Active);
            }
            break;
        case od.searchengine.SearchOption.Source:
            if (this.SearchOptionExtended) {
                this.SearchOptionExtended.SetActivityState(iascore.PanelButtonState.Active);
            }
            if (this.SearchOptionSimple) {
                this.SearchOptionSimple.SetActivityState(iascore.PanelButtonState.Active);
            }
            if (this.SearchOptionSource) {
                this.SearchOptionSource.SetActivityState(iascore.PanelButtonState.Selected);
            }
            break;
    };
};

searchBarJSP._setVisualForTempDateOptionValue = function () {
    switch (this.tempObjForSearchParams.DateOptionValue) {
        case od.searchengine.DateOption.All:
            if (this._dateOptionAll) {
                this._dateOptionAll.SetActivityState(iascore.PanelButtonState.Selected);
            }
            if (this._dateOptionWeek) {
                this._dateOptionWeek.SetActivityState(iascore.PanelButtonState.Active);
            }
            if (this._dateOptionMonth) {
                this._dateOptionMonth.SetActivityState(iascore.PanelButtonState.Active);
            }
            if (this._dateOptionCheckBox) {
                this._dateOptionCheckBox.setCheckedState(false, false);
            }
            if (this._dateOptionDatePicker) {
                this._dateOptionDatePicker.Hide();
            }
            break;
        case od.searchengine.DateOption.LastWeek:
            if (this._dateOptionAll) {
                this._dateOptionAll.SetActivityState(iascore.PanelButtonState.Active);
            }
            if (this._dateOptionWeek) {
                this._dateOptionWeek.SetActivityState(iascore.PanelButtonState.Selected);
            }
            if (this._dateOptionMonth) {
                this._dateOptionMonth.SetActivityState(iascore.PanelButtonState.Active);
            }
            if (this._dateOptionCheckBox) {
                this._dateOptionCheckBox.setCheckedState(false, false);
            }
            if (this._dateOptionDatePicker) {
                this._dateOptionDatePicker.Hide();
            }
            break;
        case od.searchengine.DateOption.LastMonth:
            if (this._dateOptionAll) {
                this._dateOptionAll.SetActivityState(iascore.PanelButtonState.Active);
            }
            if (this._dateOptionWeek) {
                this._dateOptionWeek.SetActivityState(iascore.PanelButtonState.Active);
            }
            if (this._dateOptionMonth) {
                this._dateOptionMonth.SetActivityState(iascore.PanelButtonState.Selected);
            }
            if (this._dateOptionCheckBox) {
                this._dateOptionCheckBox.setCheckedState(false, false);
            }
            if (this._dateOptionDatePicker) {
                this._dateOptionDatePicker.Hide();
            }
            break;
        default:
            if (this._dateOptionAll) {
                this._dateOptionAll.SetActivityState(iascore.PanelButtonState.Active);
            }
            if (this._dateOptionWeek) {
                this._dateOptionWeek.SetActivityState(iascore.PanelButtonState.Active);
            }
            if (this._dateOptionMonth) {
                this._dateOptionMonth.SetActivityState(iascore.PanelButtonState.Active);
            }
            if (this._dateOptionCheckBox) {
                this._dateOptionCheckBox.setCheckedState(true, false);
            }

            if (this._dateOptionDatePicker) {
                var arr = this.tempObjForSearchParams.DateOptionValue.split(".");
                var date = new Date(arr[2], arr[1] - 1, arr[0]);
                this._dateOptionDatePicker.SetSelectedDate(date);
                this._dateOptionDatePicker.Show();
            }
            break;
    };
};

searchBarJSP._setVisualForTempSortOptionValue = function () {
    switch (this.tempObjForSearchParams.SortOptionValue) {
        case od.searchengine.SortOption.Relevance:
            if (this.SortOptionRelevance) {
                this.SortOptionRelevance.SetActivityState(iascore.PanelButtonState.Selected);
            }
            if (this.SortOptionRating) {
                this.SortOptionRating.SetActivityState(iascore.PanelButtonState.Active);
            }
            if (this.SortOptionDate) {
                this.SortOptionDate.SetActivityState(iascore.PanelButtonState.Active);
            }
            break;
        case od.searchengine.SortOption.Rating:
            if (this.SortOptionRelevance) {
                this.SortOptionRelevance.SetActivityState(iascore.PanelButtonState.Active);
            }
            if (this.SortOptionRating) {
                this.SortOptionRating.SetActivityState(iascore.PanelButtonState.Selected);
            }
            if (this.SortOptionDate) {
                this.SortOptionDate.SetActivityState(iascore.PanelButtonState.Active);
            }
            break;
        case od.searchengine.SortOption.Date:
            if (this.SortOptionRelevance) {
                this.SortOptionRelevance.SetActivityState(iascore.PanelButtonState.Active);
            }
            if (this.SortOptionRating) {
                this.SortOptionRating.SetActivityState(iascore.PanelButtonState.Active);
            }
            if (this.SortOptionDate) {
                this.SortOptionDate.SetActivityState(iascore.PanelButtonState.Selected);
            }
            break;
    };
};

searchBarJSP._setVisualForTempAdvancedFilterFavoriteValue = function () {
    switch (this.tempObjForSearchParams.AdvancedFilterFavoriteValue) {
        case od.searchengine.AdvancedFilterFavoriteElement.All:
            this.AdvancedFilterFavoriteCheckBox.setCheckedState(false, false);
            break;
        case od.searchengine.AdvancedFilterFavoriteElement.Favorite:
            this.AdvancedFilterFavoriteCheckBox.setCheckedState(true, false);
            break;
    };
};

searchBarJSP._setVisualForTempAdvancedFilterCommentValue = function () {
    switch (this.tempObjForSearchParams.AdvancedFilterCommentValue) {
        case od.searchengine.AdvancedFilterCommentElement.All:
            this.AdvancedFilterCommentCheckBox.setCheckedState(false, false);
            break;
        case od.searchengine.AdvancedFilterCommentElement.Comment:
            this.AdvancedFilterCommentCheckBox.setCheckedState(true, false);
            break;
    };
};

searchBarJSP._initTempObjForSearchParams = function () {
    this.tempObjForSearchParams =
    {
        ResultsFilterValue: this.ResultsFilterValue,
        SortOptionValue: this.SortOptionValue,
        SearchOptionValue: this.SearchOptionValue,
        AdvancedFilterFavoriteValue: this.AdvancedFilterFavoriteValue,
        AdvancedFilterCommentValue: this.AdvancedFilterCommentValue,
        DateOptionValue: this.DateOptionValue
    };

    this._setVisualForTempResultsFilterValue();
    this._setVisualForTempSearchOptionValue();
    this._setVisualForTempDateOptionValue();
    this._setVisualForTempSortOptionValue();
    this._setVisualForTempAdvancedFilterFavoriteValue();
    this._setVisualForTempAdvancedFilterCommentValue();
};

searchBarJSP._saveTempObjForSearchParams = function () {
    this.SetResultsFilterValueUI(this.tempObjForSearchParams.ResultsFilterValue);
    this.SetSearchOptionValueUI(this.tempObjForSearchParams.SearchOptionValue);
    this.SetDateOptionValueUI(this.tempObjForSearchParams.DateOptionValue);
    this.SetSortOptionValueUI(this.tempObjForSearchParams.SortOptionValue);
    this.SetAdvancedFilterValueUI(this.tempObjForSearchParams.AdvancedFilterFavoriteValue, this.tempObjForSearchParams.AdvancedFilterCommentValue);
};

searchBarJSP._InitBaseFunction =
function (instanceName, clientID, textBoxID, dropDownID, dropDownDisplayParentID, statsHolderID, sortHolderID, resultsFilterHolderID, sortOptionsHolderID, searchOptionsHolderID, userHistoryLinkID, advancedFilterHolderID, dateOptionsHolderID) {
    this.InstanceName = instanceName;
    this.ClientID = clientID;
    this.TextBoxID = textBoxID;
    this.DropDownID = dropDownID;
    this.DropDownDisplayParentID = dropDownDisplayParentID;
    this.TextBoxJQ = $('#' + this.TextBoxID);
    this.DropDownJQ = $('#' + this.DropDownID);
    this.DropDownJQDisplayParent = $('#' + this.DropDownDisplayParentID);
    this.SortHolderID = sortHolderID;

    if (statsHolderID) {
        this.StatsHolder = document.getElementById(statsHolderID);
    }

    this.SelectedTermIdx = -1;

    var self = this;
    var TextBox_onChangeCall = function (event) {
        self.TextBox_onChange(event, self);
    };

    //this.TextBoxJQ.bind('focus', this.TextBox_onFocus);
    //this.TextBoxJQ.bind('blur', this.TextBox_onBlur);
    this.TextBoxJQ.bind('keyup', TextBox_onChangeCall);
    this.TextBoxJQ.bind('keydown', this.TextBox_onSubmit);
    this.TextBoxJQ.bind('cut', TextBox_onChangeCall);
    this.TextBoxJQ.bind('paste', TextBox_onChangeCall);

    // для FireFox
    if ($.browser.mozilla) {
        this.TextBoxJQ.val("");
        this.TextBoxJQ.blur();
    }

    this.ResultsFilterHolder = document.getElementById(resultsFilterHolderID);

    if (this.ResultsFilterHolder) {
        this.ResultsFilterHolder.style.marginBottom = "5px";

        var filterLabel = document.createElement("span");
        filterLabel.innerHTML = "Искать";
        filterLabel.className = "Label";
        this.ResultsFilterHolder.appendChild(filterLabel);

        var panel = new iascore.ButtonsPanel({
            ParentNode: this.ResultsFilterHolder,
            ButtonsParam: [{
                Index: "ResultsFilterOptionAll",
                Width: 157,
                Content: "Во всех разделах",
                Click: function () { self.tempObjForSearchParams.ResultsFilterValue = od.searchengine.ResultsFilter.All; self._setVisualForTempResultsFilterValue(); }
            }, {
                Index: "ResultsFilterOptionDocs",
                Width: 131,
                Content: "В документах",
                Click: function () { self.tempObjForSearchParams.ResultsFilterValue = od.searchengine.ResultsFilter.Documents; self._setVisualForTempResultsFilterValue(); }
            }, {
                Index: "ResultsFilterOptionFacts",
                Width: 132,
                Content: "В показателях",
                Click: function () { self.tempObjForSearchParams.ResultsFilterValue = od.searchengine.ResultsFilter.Facts; self._setVisualForTempResultsFilterValue(); }
            }]
        });

        this.ResultsFilterOptionAll = panel.GetButtonByIndex("ResultsFilterOptionAll");
        this.ResultsFilterOptionDocs = panel.GetButtonByIndex("ResultsFilterOptionDocs");
        this.ResultsFilterOptionFacts = panel.GetButtonByIndex("ResultsFilterOptionFacts");

        this.SetResultsFilterValueUI(this.ResultsFilterValue);
    }

    this.SortOptionsHolder = document.getElementById(sortOptionsHolderID);

    if (this.SortOptionsHolder) {
        this.SortOptionsHolder.style.marginBottom = "18px";

        var sortLabel = document.createElement("span");
        sortLabel.innerHTML = "Сортировать";
        sortLabel.className = "Label";
        this.SortOptionsHolder.appendChild(sortLabel);

        var panel = new iascore.ButtonsPanel({
            ParentNode: this.SortOptionsHolder,
            ButtonsParam: [{
                Index: "SortOptionRelevance",
                Width: 166,
                Content: "По релевантности",
                Click: function () { self.tempObjForSearchParams.SortOptionValue = od.searchengine.SortOption.Relevance; self._setVisualForTempSortOptionValue(); }
            }, {
                Index: "SortOptionRating",
                Width: 163,
                Content: "По популярности",
                Click: function () { self.tempObjForSearchParams.SortOptionValue = od.searchengine.SortOption.Rating; self._setVisualForTempSortOptionValue(); }
            }, {
                Index: "SortOptionDate",
                Width: 183,
                Content: "По дате публикации",
                Click: function () { self.tempObjForSearchParams.SortOptionValue = od.searchengine.SortOption.Date; self._setVisualForTempSortOptionValue(); }
            }]
        });

        this.SortOptionRelevance = panel.GetButtonByIndex("SortOptionRelevance");
        this.SortOptionRating = panel.GetButtonByIndex("SortOptionRating");
        this.SortOptionDate = panel.GetButtonByIndex("SortOptionDate");

        this.SetSortOptionValueUI(this.SortOptionValue);
    }

    this.SearchOptionHolder = document.getElementById(searchOptionsHolderID);

    if (this.SearchOptionHolder) {
        var searchLabel = document.createElement("span");
        searchLabel.innerHTML = "Учитывать";
        searchLabel.className = "Label";
        this.SearchOptionHolder.appendChild(searchLabel);

        var panel = new iascore.ButtonsPanel({
            ParentNode: this.SearchOptionHolder,
            ButtonsParam: [{
                Index: "SearchOptionExtended",
                Width: 134,
                Content: "Все атрибуты",
                Click: function () { self.tempObjForSearchParams.SearchOptionValue = od.searchengine.SearchOption.Extended; self._setVisualForTempSearchOptionValue(); }
            }, {
                Index: "SearchOptionSimple",
                Width: 146,
                Content: "Наименование",
                Click: function () { self.tempObjForSearchParams.SearchOptionValue = od.searchengine.SearchOption.Simple; self._setVisualForTempSearchOptionValue(); }
            }, {
                Index: "SearchOptionSource",
                Width: 105,
                Content: "Источник",
                Click: function () { self.tempObjForSearchParams.SearchOptionValue = od.searchengine.SearchOption.Source; self._setVisualForTempSearchOptionValue(); }
            }]
        });

        this.SearchOptionExtended = panel.GetButtonByIndex("SearchOptionExtended");
        this.SearchOptionSimple = panel.GetButtonByIndex("SearchOptionSimple");
        this.SearchOptionSource = panel.GetButtonByIndex("SearchOptionSource");

        this.SetSearchOptionValueUI(this.SearchOptionValue);
    }

    this.AdvancedFilterHolder = document.getElementById(advancedFilterHolderID);

    if (this.AdvancedFilterHolder) {
        var advancedFilterLabel = document.createElement("span");
        advancedFilterLabel.style.paddingTop = "16px";
        advancedFilterLabel.innerHTML = "Отобрать";
        advancedFilterLabel.className = "Label";
        this.AdvancedFilterHolder.appendChild(advancedFilterLabel);

        this.AdvancedFilterFavoriteCheckBox = new PP.Ui.CheckBox({
            ParentNode: this.AdvancedFilterHolder,
            Checked: false,
            Content: "Только избранное",
            CheckedChanged: function (sender, args) {
                var favorite = od.searchengine.AdvancedFilterFavoriteElement.All;
                if (sender.getChecked()) {
                    favorite = od.searchengine.AdvancedFilterFavoriteElement.Favorite;
                } else {
                    favorite = od.searchengine.AdvancedFilterFavoriteElement.All;
                }
                self.tempObjForSearchParams.AdvancedFilterFavoriteValue = favorite;
                self._setVisualForTempAdvancedFilterFavoriteValue();
            },
            Style: 'width: 160px; position: absolute; top:24px;',
            MouseDown: function () { this.addClass('Active'); },
            MouseUp: function () { this.removeClass('Active'); },
            MouseOut: function () { this.removeClass('Active'); }
        });
        this.AdvancedFilterFavoriteCheckBox.addClass("SearchBarTextBox Short Grey");

        this.AdvancedFilterCommentCheckBox = new PP.Ui.CheckBox({
            ParentNode: this.AdvancedFilterHolder,
            Checked: false,
            Content: "Только комментарии",
            CheckedChanged: function (sender, args) {
                var comment = od.searchengine.AdvancedFilterCommentElement.All;
                if (sender.getChecked()) {
                    comment = od.searchengine.AdvancedFilterCommentElement.Comment;
                } else {
                    comment = od.searchengine.AdvancedFilterCommentElement.All;
                }
                self.tempObjForSearchParams.AdvancedFilterCommentValue = comment;
                self._setVisualForTempAdvancedFilterCommentValue();
            },
            Style: 'width: 160px; position: absolute; top: 50px;',
            MouseDown: function () { this.addClass('Active'); },
            MouseUp: function () { this.removeClass('Active'); },
            MouseOut: function () { this.removeClass('Active'); }
        });
        this.AdvancedFilterCommentCheckBox.addClass("SearchBarTextBox Short Grey");

        this.AdvancedFilterHolder.style.height = "95px";

        this.SetAdvancedFilterValueUI(this.AdvancedFilterFavoriteValue, this.AdvancedFilterCommentValue);
    }

    this._dateOptionsHolder = document.getElementById(dateOptionsHolderID);

    if (this._dateOptionsHolder) {
        var self = this;

        var dateOptionsLabel = document.createElement("span");
        dateOptionsLabel.innerHTML = "Дата обновления";
        dateOptionsLabel.className = "Label";
        this._dateOptionsHolder.appendChild(dateOptionsLabel);

        var panel = new iascore.ButtonsPanel({
            ParentNode: this._dateOptionsHolder,
            ButtonsParam: [{
                Index: "DateOptionAll",
                Width: 144,
                Content: "Все материалы",
                Click: function () {
                    self.tempObjForSearchParams.DateOptionValue = od.searchengine.DateOption.All;
                    self._setVisualForTempDateOptionValue();
                }
            }, {
                Index: "DateOptionWeek",
                Width: 191,
                Content: "За последнюю неделю",
                Click: function () {
                    self.tempObjForSearchParams.DateOptionValue = od.searchengine.DateOption.LastWeek;
                    self._setVisualForTempDateOptionValue();
                }
            }, {
                Index: "DateOptionMonth",
                Width: 176,
                Content: "За последний месяц",
                Click: function () {
                    self.tempObjForSearchParams.DateOptionValue = od.searchengine.DateOption.LastMonth;
                    self._setVisualForTempDateOptionValue();
                }
            }]
        });

        this._dateOptionAll = panel.GetButtonByIndex("DateOptionAll");
        this._dateOptionWeek = panel.GetButtonByIndex("DateOptionWeek");
        this._dateOptionMonth = panel.GetButtonByIndex("DateOptionMonth");

        this._dateOptionCheckBox = new PP.Ui.CheckBox({
            ParentNode: this._dateOptionsHolder,
            Checked: false,
            Content: "Конкретная дата",
            CheckedChanged: function (sender, args) {
                if (sender.getChecked()) {
                    self.tempObjForSearchParams.DateOptionValue = self._dateOptionDatePicker.GetSelectedDate();
                    self._setVisualForTempDateOptionValue();
                    self._dateOptionDatePicker.Show();
                } else {
                    self.tempObjForSearchParams.DateOptionValue = od.searchengine.DateOption.All;
                    self._setVisualForTempDateOptionValue();
                    self._dateOptionDatePicker.Hide();
                }
            },
            Style: "position: absolute; top: 52px; left: 138px;",
            MouseDown: function () { this.addClass('Active'); },
            MouseUp: function () { this.removeClass('Active'); },
            MouseOut: function () { this.removeClass('Active'); }
        });
        this._dateOptionCheckBox.addClass("SearchBarTextBox Short Grey");

        this._dateOptionDatePicker = new iascore.DatePicker({
            ParentNode: this._dateOptionsHolder,
            Width: 126,
            Style: "position: absolute; top: 48px; left: 285px;"
        });
        this._dateOptionDatePicker.Hide();

        this._dateOptionsHolder.style.height = "98px";

        var dt_p = this._dateOptionDatePicker;
        this._dateOptionDatePicker.AfterDateChange = function () {
            self.tempObjForSearchParams.DateOptionValue = dt_p.GetSelectedDate();
            self._setVisualForTempDateOptionValue();
        };

        this.SetDateOptionValueUI(od.searchengine.DateOption.All);
    }

    this.UserHistoryLink = document.getElementById(userHistoryLinkID);
    this.UserHistoryWindow = null;
    this.UserHistoryWindowContent = null;
    this.UserHistoryScrollBox = null;

    if (this.UserHistoryLink) {
        this.UserHistoryLink.onclick = function () { self.ShowUserHistory(); };
    }

    if (this.SortHolderID) {
        this.BuildSortCombo();
    }
};

searchBarJSP.ChangeComboSortSelection = function (selfinst) {
    iascore.StartProgress();
    var selection_param = selfinst._comboSortParam.ComboBox.getTreeList().getSelectedNodes()[0].getData();
    //selfinst.SetSortOptionDopValue(selection_param);
    selfinst.SetSortOptionValue(selection_param);
};

searchBarJSP.BuildSortCombo = function () {
    if (typeof (od.TreeComboInNewDesign) != "undefined" && document.getElementById(this.SortHolderID) != null) {
        var combo = new SortCombo();
        var sb = this;
        var vNodesForSort = combo.GetSortNodes(function (nodes) {            
            sb._comboSortParam = new od.TreeComboInNewDesign(nodes, document.getElementById(sb.SortHolderID), 201, 28, "ResultSortCombo", sb.ChangeComboSortSelection, sb, "Sort");
        });
            /*[{
            Id: "0",
            Text: "По релевантности",
            Data: 0,
            Columns: ["По релевантности"]
        },
            { Id: "1",
                Text: "По дате изменения",
                Data: 3,
                Columns: ["По дате изменения"]
            },
            {
                Id: "2",
                Text: "По наименованию",
                Data: 4,
                Columns: ["По наименованию"]
            }
        ];*/
        //this._comboSortParam = new od.TreeComboInNewDesign(vNodesForSort, document.getElementById(this.SortHolderID), 201, 28, "ResultSortCombo", this.ChangeComboSortSelection, this, "Sort");
    }
};

searchBarJSP.TextBox_onSubmit = function (event) {
    if (event.keyCode == 13) {
        event.stopPropagation ? event.stopPropagation() : event.cancelBubble = true;
        return false;
    }
};

searchBarJSP.TextBox_onChange = function (event, self) {
    switch (event.type) {
        case "paste":
            // self.FindDropDown(event, self);
            break;
        case "cut":
            // self.FindDropDown(event, self);
            break;
        case "keyup":
            switch (event.keyCode) {
                case 38:
                    /*
                    * УДАЛЯЕМ ВЫПАДАШКУ С ПОДСКАЗКАМИ ПОИСКА ТАК КАК РАБОТАЕТ ОНА ПЛОХО МЕДЛЕННО И УЖАСНО
                    var a = $("#" + self.DropDownID + " > div");
                    if (a.length > 0 && self.SelectedTermIdx > 0) {
                        self.SelectedTermIdx--;
                        $(a[self.SelectedTermIdx]).removeClass('NotActive');
                        $(a[self.SelectedTermIdx]).addClass('Active');
                        if (a[self.SelectedTermIdx].getAttribute("srcValue"))
                            self.TextBoxJQ.val(a[self.SelectedTermIdx].getAttribute("srcValue").trim());
                        if (a[self.SelectedTermIdx + 1]) {
                            $(a[self.SelectedTermIdx + 1]).removeClass('Active');
                            $(a[self.SelectedTermIdx + 1]).addClass('NotActive');
                        }
                    }*/
                    break; 
                case 40:
                case 39:
                    /*
                    * УДАЛЯЕМ ВЫПАДАШКУ С ПОДСКАЗКАМИ ПОИСКА ТАК КАК РАБОТАЕТ ОНА ПЛОХО МЕДЛЕННО И УЖАСНО
                    var a = $("#" + self.DropDownID + " > div");
                    if (a.length > 0 && self.SelectedTermIdx < a.length - 1) {
                        self.SelectedTermIdx++;
                        $(a[self.SelectedTermIdx]).removeClass('NotActive');
                        $(a[self.SelectedTermIdx]).addClass('Active');
                        if (a[self.SelectedTermIdx].getAttribute("srcValue"))
                            self.TextBoxJQ.val(a[self.SelectedTermIdx].getAttribute("srcValue").trim());
                        if (a[self.SelectedTermIdx - 1]) {
                            $(a[self.SelectedTermIdx - 1]).removeClass('Active');
                            $(a[self.SelectedTermIdx - 1]).addClass('NotActive');
                        }
                    }
                    */
                    break;
                case 27:
                    /*
                    * УДАЛЯЕМ ВЫПАДАШКУ С ПОДСКАЗКАМИ ПОИСКА ТАК КАК РАБОТАЕТ ОНА ПЛОХО МЕДЛЕННО И УЖАСНО
                    event.stopPropagation ? event.stopPropagation() : event.cancelBubble = true;
                    $(event.currentTarget).blur();
                    self.DropDownJQDisplayParent.css("display", "none");
                    self.DropDownJQ[0].innerHTML = "<div class=\"txtFindDropDownItem NotActive\"><div class=\"Line LeftLine Single\"></div><div class=\"Line RightLine Single\"></div><div class=\"SearchTxt\"></div></div>";
                    self.SelectedTermIdx = -1;
                    return false;
                    */
                    break;
                case 13:
                    event.stopPropagation ? event.stopPropagation() : event.cancelBubble = true;
                    iascore.StartProgress();
                    self.StartSearch(true);
                    return false;
                    break;
                default:
                    var a = $("#" + self.DropDownID + " > div");
                    if (a[self.SelectedTermIdx]) {
                        $(a[self.SelectedTermIdx]).removeClass('Active');
                        $(a[self.SelectedTermIdx]).addClass('NotActive');
                    }
                    self.SelectedTermIdx = -1;
                    if (self.OldText != self.TextBoxJQ.val()) {
                        self.FindDropDown(event, self);
                    }
                    break;
            }
            break;
    }
    self.OldText = self.TextBoxJQ.val();
};

searchBarJSP.StartSearch = function (saveRequest) {
    if (this.CurrentDelayID)
        clearTimeout(this.CurrentDelayID);

    this.TextBoxJQ.blur();
    this.DropDownJQDisplayParent.css("display", "none");
    if (this.DropDownJQ[0]) {
        this.DropDownJQ[0].innerHTML = "<div class=\"txtFindDropDownItem NotActive\"><div class=\"Line LeftLine Single\"></div><div class=\"Line RightLine Single\"></div><div class=\"SearchTxt\"></div></div>";
    }
    this.SelectedTermIdx = -1;
    //debugger;
    this.StartSearchBase(saveRequest, this.TextBoxJQ.val());
};

searchBarJSP.FindDropDown = function (event, self) {
    var findStr = $(event.currentTarget).val();
    findStr = findStr.replace(/'/g, '');
    var startSearchTermsCallback = false;
    
    if (self.DropDownJQDisplayParent.css("display") == "none") {
        if (findStr.length >= 2) {
            // СКРЫВАЕМ ВЫПАДАШКУ С ПОДСКАЗКАМИ
            //self.DropDownJQDisplayParent.css("display", "block");
            startSearchTermsCallback = self.HighlightSearchTerms(findStr);
        }
    }
    else {
        if (findStr.length < 2) {
            self.DropDownJQDisplayParent.css("display", "none");
            self.DropDownJQ[0].innerHTML = "<div class=\"txtFindDropDownItem NotActive\"><div class=\"Line LeftLine Single\"></div><div class=\"Line RightLine Single\"></div><div class=\"SearchTxt\"></div></div>";
            self.SelectedTermIdx = -1;
        }
        else {
            startSearchTermsCallback = self.HighlightSearchTerms(findStr);
        }
    }

    if (findStr.charAt(findStr.length - 1) == " ")
        startSearchTermsCallback = true;

    if (startSearchTermsCallback || event.keyCode == 8) {
        if (self.CurrentDelayID)
            clearTimeout(self.CurrentDelayID);
        if (self.IsFindCallback.length == 0) {
            var txt = self.TextBoxJQ[0];
            txt.readonly = true;

            var SearchTermsSendRequestCall = function () {
                var requestID = (Math.random() * 100000).toFixed(0);
                self.SearchTermsSendRequest(findStr, requestID, self);
            }
            self.CurrentDelayID = setTimeout(SearchTermsSendRequestCall, 500); 


        }
    }
};

searchBarJSP.HighlightSearchTerms = function (findStr) {
    var result = false;
    var termsCount = 0;
    var a = $("#" + this.DropDownID + " > div");
    for (var i = 0; i < a.length; i++) {
        var srcValue = a[i].getAttribute("srcValue");

        if (srcValue) {

            a[i].setAttribute('term_index', termsCount);

            var self = this;

            var SearchTermsOnClickCall = function (event) {
                self.SearchTermsOnClick(event, self);
            };
            $(a[i]).bind('click', SearchTermsOnClickCall);
            $(a[i]).bind('mousedown', SearchTermsOnClickCall);

            if (srcValue.indexOf(findStr) >= 0) {
                a[i].childNodes[2].innerHTML = srcValue.replace(findStr, "<b>" + findStr + "</b>");
                termsCount++;
            }
            else {
                a[i].childNodes[2].innerHTML = srcValue;
            }

        }

    }

    if ((a.length == 0) || (a.length > 0 && termsCount == 0)) {
        result = true;
    }
    return result;
};

searchBarJSP.SearchTermsSendRequest = function (findStr, requestID, self) {
    self.DropDownJQ[0].innerHTML = "<div class=\"txtFindDropDownItem NotActive\"><div class=\"Line LeftLine Single\"></div><div class=\"Line RightLine Single\"></div><div class=\"SearchTxt\">Поиск...</div></div>";

    var postData = "FSTR=" + findStr + ";REQID=" + requestID;
    var httpRequestUrl = od.pageCorrector + "SearchEngine/HSEGetPrompterTerms.ashx";

    var searchTermsHttpRequest = new iascore.RequestManager(postData, httpRequestUrl);
    searchTermsHttpRequest.Sender = self;
    searchTermsHttpRequest.RequestComplete = self.SearchTermsCallbackComplete;
    searchTermsHttpRequest.AfterRequestComplete = function (sender) {
        var txt = sender.TextBoxJQ[0];
        txt.readonly = false;
        txt.focus();
    };
    self.IsFindCallback.push(requestID);
    searchTermsHttpRequest.Send();
};

searchBarJSP.SearchTermsCallbackComplete = function (sender, args) {
    var contentParts = args.split("#");
    if (contentParts[0] && contentParts[1]) {
            sender.DropDownJQ[0].innerHTML = contentParts[0];
            sender.HighlightSearchTerms(sender.TextBoxJQ.val());
            sender.SelectedTermIdx = -1;
            for (var i = 0; i < sender.IsFindCallback.length; i++) {
                if (sender.IsFindCallback[i] == contentParts[1]) {
                    sender.IsFindCallback.splice(i, 1);
                    break;
                }
            }
    }
    else {
        AlertWindow.show("Ошибка", 'При запросе данных произошла ошибка. Пожалуйста, обратитесь к администратору.');
    }
};

searchBarJSP.SearchTermsOnClick = function (e, self) {
    var serchTermIndex = e.target.getAttribute('term_index');
    if (serchTermIndex == null && e.target.parentNode) {
        serchTermIndex = e.target.parentNode.getAttribute('term_index')
        if (serchTermIndex == null && e.target.parentNode.parentNode) {
            serchTermIndex = e.target.parentNode.parentNode.getAttribute('term_index')
        }
    }

    if (serchTermIndex != null) {
        var a = $("#" + self.DropDownID + " > div");
        if (a.length > 0 && serchTermIndex >= 0) {
            iascore.StartProgress();
            self.TextBoxJQ.val(a[serchTermIndex].getAttribute("srcValue").trim());
            self.DropDownJQDisplayParent.css("display", "none");
            self.DropDownJQ[0].innerHTML = "<div class=\"txtFindDropDownItem NotActive\"><div class=\"Line LeftLine Single\"></div><div class=\"Line RightLine Single\"></div><div class=\"SearchTxt\"></div></div>";
            self.SelectedTermIdx = -1;
            self.StartSearch(false);
        }
    }
};

searchBarJSP.SetResultsFilterValueUI = function (value) {
    var self = this;
    switch (value) {
        case od.searchengine.ResultsFilter.All:
            if (this._filterParamFactor) {
                this._filterParamFactor.setCheckedState(true, false);
            }
            if (this._filterParamDocument) {
                this._filterParamDocument.setCheckedState(true, false);
            }
            break;
        case od.searchengine.ResultsFilter.Documents:
            if (this._filterParamFactor) {
                this._filterParamFactor.setCheckedState(false, false);
            }
            if (this._filterParamDocument) {
                this._filterParamDocument.setCheckedState(true, false);
            }
            break;
        case od.searchengine.ResultsFilter.Facts:
            if (this._filterParamFactor) {
                this._filterParamFactor.setCheckedState(true, false);
            }
            if (this._filterParamDocument) {
                this._filterParamDocument.setCheckedState(false, false);
            }
            break;
        case od.searchengine.ResultsFilter.None:
            if (this._filterParamFactor) {
                this._filterParamFactor.setCheckedState(false, false);
            }
            if (this._filterParamDocument) {
                this._filterParamDocument.setCheckedState(false, false);
            }
            break;
    }

    this.ResultsFilterValue = value;
    if (this.ResultsViewer) {
        this.ResultsViewer.ResultsFilterValue = value;
    }
};

searchBarJSP.SetSortOptionValueUI = function (value) {
    var self = this;
    this.SortOptionValue = value;
    if (this.ResultsViewer) {
        this.ResultsViewer.SortOptionValue = value;
    }
};

searchBarJSP.SetSearchOptionValueUI = function (value) {
    var self = this;
    this.SearchOptionValue = value;
    if (this.ResultsViewer) {
        this.ResultsViewer.SearchOptionValue = value;
    }
};

searchBarJSP.SetAdvancedFilterValueUI = function (favoriteValue, commentValue) {
    this.AdvancedFilterFavoriteValue = favoriteValue;
    this.AdvancedFilterCommentValue = commentValue;
    if (this.ResultsViewer) {
        this.ResultsViewer.AdvancedFilterFavoriteElementValue = favoriteValue;
        this.ResultsViewer.AdvancedFilterCommentElementValue = commentValue;
    }
};

searchBarJSP.ShowStats = function (stats) {
    if (this.StatsHolder) {
        this.StatsHolder.innerHTML = "";

        var content = "Результаты поиска: ";

        if (stats.pageCount > 0) {

            if (stats.factCount > 0) {
                var factCaption = "";
                var factCountStr = stats.factCount.toString();
                var factCountSuffix = factCountStr.length >= 2
                        ? parseInt(factCountStr.substr(factCountStr.length - 2, 2))
                        : parseInt(factCountStr.substr(factCountStr.length - 1, 1));

                if (factCountSuffix >= 10 && factCountSuffix <= 20) {
                    factCaption = "наборов данных";
                }
                else {
                    factCountSuffix = parseInt(factCountStr.substr(factCountStr.length - 1, 1));
                    switch (factCountSuffix) {
                        case 1:
                            factCaption = "набор данных";
                            break;
                        case 2:
                        case 3:
                        case 4:
                            factCaption = "набора данных";
                            break;
                        default:
                            factCaption = "наборов данных";
                            break;

                    }
                }

                content += "<span>" + factCountStr + "</span> " + factCaption;
            }

            if (stats.docCount > 0) {
                if (stats.factCount > 0) {
                    content += ", ";
                }

                var docCaption = "";
                var docCountStr = stats.docCount.toString();
                var docCountSuffix = docCountStr.length >= 2
                        ? parseInt(docCountStr.substr(docCountStr.length - 2, 2))
                        : parseInt(docCountStr.substr(docCountStr.length - 1, 1));

                if (docCountSuffix >= 10 && docCountSuffix <= 20) {
                    docCaption = "документов";
                }
                else {
                    docCountSuffix = parseInt(docCountStr.substr(docCountStr.length - 1, 1));
                    switch (docCountSuffix) {
                        case 1:
                            docCaption = "документ";
                            break;
                        case 2:
                        case 3:
                        case 4:
                            docCaption = "документа";
                            break;
                        default:
                            docCaption = "документов";
                            break;

                    }
                }

                content += "<span>" + docCountStr + "</span> " + docCaption;
            }

            if (stats.pollCount > 0) {
                if (stats.factCount > 0 || stats.docCount > 0) {
                    content += ", ";
                }

                var pollCaption = "";
                var pollCountStr = stats.pollCount.toString();
                var pollCountSuffix = pollCountStr.length >= 2
                        ? parseInt(pollCountStr.substr(pollCountStr.length - 2, 2))
                        : parseInt(pollCountStr.substr(pollCountStr.length - 1, 1));

                if (pollCountSuffix >= 10 && pollCountSuffix <= 20) {
                    pollCaption = "опросов";
                }
                else {
                    pollCountSuffix = parseInt(pollCountStr.substr(pollCountStr.length - 1, 1));
                    switch (pollCountSuffix) {
                        case 1:
                            pollCaption = "опрос";
                            break;
                        case 2:
                        case 3:
                        case 4:
                            pollCaption = "опроса";
                            break;
                        default:
                            pollCaption = "опросов";
                            break;

                    }
                }

                content += "<span>" + pollCountStr + "</span> " + pollCaption;
            }

            if (stats.proposalCount > 0) {
                if (stats.factCount > 0 || stats.docCount > 0 || stats.pollCount > 0) {
                    content += ", ";
                }

                var proposalCaption = "";
                var proposalCountStr = stats.proposalCount.toString();
                var proposalCountSuffix = proposalCountStr.length >= 2
                        ? parseInt(proposalCountStr.substr(proposalCountStr.length - 2, 2))
                        : parseInt(proposalCountStr.substr(proposalCountStr.length - 1, 1));

                if (proposalCountSuffix >= 10 && proposalCountSuffix <= 20) {
                    proposalCaption = "предложений";
                }
                else {
                    proposalCountSuffix = parseInt(proposalCountStr.substr(proposalCountStr.length - 1, 1));
                    switch (proposalCountSuffix) {
                        case 1:
                            proposalCaption = "предложение";
                            break;
                        case 2:
                        case 3:
                        case 4:
                            proposalCaption = "предложения";
                            break;
                        default:
                            proposalCaption = "предложений";
                            break;

                    }
                }

                content += "<span>" + proposalCountStr + "</span> " + proposalCaption;
            }

            if (stats.pageCount > 1) {
                var pageCaption = "";
                var pageCountStr = stats.pageCount.toString();
                var pageCountSuffix = pageCountStr.length >= 2
                        ? parseInt(pageCountStr.substr(pageCountStr.length - 2, 2))
                        : parseInt(pageCountStr.substr(pageCountStr.length - 1, 1));

                if (pageCountSuffix >= 10 && pageCountSuffix <= 20) {
                    pageCaption = "страницах";
                }
                else {
                    pageCountSuffix = parseInt(pageCountStr.substr(pageCountStr.length - 1, 1));
                    switch (pageCountSuffix) {
                        case 1:
                            pageCaption = "странице";
                            break;
                        default:
                            pageCaption = "страницах";
                            break;

                    }
                }

                content += " на <span>" + pageCountStr + "</span> " + pageCaption;

            }


        }
        else {
            content += "ничего не найдено";
        }

        this.StatsHolder.innerHTML = content;


    }
};

searchBarJSP.SetText = function (text) {
    this.ResultsViewer.FindString = iascore.HtmlDecode(text);
    this.TextBoxJQ.val(iascore.HtmlDecode(text));
};

searchBarJSP.ShowUserHistoryLink = function (isShow) {
    this.UserHistoryLink.style.display = isShow ? "block" : "none";
};

searchBarJSP.ShowUserHistory = function () {
    iascore.StartProgress();

    if (!this.UserHistoryWindow) {
        this._createHistoryWindow();
    }

    this.UserHistoryWindow.showDialog();
    this.UserHistoryScrollBox.setSize(this.UserHistoryWindow.getContentWidth() - 2, this.UserHistoryWindow.getContentHeight() - 2);
    this.UserHistoryWindowContent.innerHTML = "";
    this.UserHistoryScrollBox.updateScrollsVisibility(false);

    var httpRequest = new iascore.RequestManager("?", od.pageCorrector + "Handlers/HGetUserQueries.ashx");
    httpRequest.Sender = this;
    httpRequest.RequestComplete = function (sender, args) {
        sender.UserHistoryWindowContent.innerHTML = args;
        var linkHolders = $(sender.UserHistoryWindowContent).find(".TC_Cloud");
        for (var i = 0; i < linkHolders.length; i++) {
            var linkHolder = linkHolders[i];
            var text = linkHolder.getAttribute("tagVal");
            linkHolder.innerHTML = "<a class=\"Tag\" style=\"font-size: 14px;\" href=\"javascript:void(0);\" onfocus=\"this.blur();\" onclick=\"" + sender.InstanceName + ".CallUserQuery('" + text + "');\" >" + text + "</a>";
        }
        sender.UserHistoryScrollBox.updateScrollsVisibility(false);
    };
    httpRequest.AfterRequestComplete = function (sender) {
        iascore.StopProgress();
    };
    httpRequest.Send();
};

searchBarJSP.CallUserQuery = function (text) {
    this.UserHistoryWindow.hide();
    this.SetText(text);
    if (this.ResultsViewer.ResultsHolder) {
        this.StartSearch(false);
    }
};

searchBarJSP._createHistoryWindow = function () {
    this.UserHistoryWindow = new PP.Ui.Window({
        ParentNode: document.body,
        Caption: "История поиска",
        CaptionIcon: od.pageCorrector + "Images/SearchBar/search-16.png",
        Height: 450,
        Width: 650,
        MaxDropDownHeight: document.documentElement.clientHeight,
        MaxDropDownWidth: document.documentElement.clientWidth,
        MinDropDownHeight: 200,
        MinDropDownWidth: 240,
        UseScrollBox: true
    });
    this.UserHistoryWindow.setIsResizable(false);
    this.UserHistoryWindowContent = document.createElement("div");
    this.UserHistoryWindowContent.style.padding = "0 20px 20px 20px";
    this.UserHistoryWindowContent.style.backgroundColor = "#FFF";
    this.UserHistoryScrollBox = new PP.Ui.ScrollBox({
        Content: this.UserHistoryWindowContent,
        Style: "background-color: #FFF;"
    });
    this.UserHistoryWindow.setContent(this.UserHistoryScrollBox);
    var self = this;


};

searchBarJSP._setFilterValue = function () {
    if (this._filterParamFactor.getCheckedState() && this._filterParamDocument.getCheckedState()) {
        this.SetResultsFilterValue(od.searchengine.ResultsFilter.All);
    }

    if (this._filterParamFactor.getCheckedState() && !this._filterParamDocument.getCheckedState()) {
        this.SetResultsFilterValue(od.searchengine.ResultsFilter.Facts);
    }

    if (!this._filterParamFactor.getCheckedState() && this._filterParamDocument.getCheckedState()) {
        this.SetResultsFilterValue(od.searchengine.ResultsFilter.Documents);
    }

    if (!this._filterParamFactor.getCheckedState() && !this._filterParamDocument.getCheckedState()) {
        this.SetResultsFilterValue(od.searchengine.ResultsFilter.None);
        AlertWindow.show("Предупреждение", "Независимо от поискового запроса результат будет пустым. Укажите параметр поиска");
    }
}

searchBarJSP._onActivateSearchString = function () {
    $(document.getElementById(this.InstanceName + "_SearchTextBox")).addClass('Active');    

    document.getElementById(this.InstanceName + "_ImgDelValue").style.display = "block";
}

searchBarJSP._onBlurSearchString = function () {
    if (document.getElementById(this.InstanceName + "_ImgDelValue").getAttribute("prCursor") == "0") {
        if (!this._showShortView) {
            $(document.getElementById(this.InstanceName + "_SearchTextBox")).removeClass('Active');
            document.getElementById(this.InstanceName + "_ImgDelValue").style.display = "none";
        }
        this.DropDownJQDisplayParent.css("display", "none");
    }
}

searchBarJSP._DelValueforSearchString = function (owner) {
    this.SetText("");
    this.DropDownJQ[0].innerHTML = "<div class=\"txtFindDropDownItem NotActive\"><div class=\"Line LeftLine Single\"></div><div class=\"Line RightLine Single\"></div><div class=\"SearchTxt\"></div></div>";
    this.SelectedTermIdx = -1;
    this.OldText = "";
    document.getElementById(this.InstanceName + "_ImgDelValue").style.display = "none";
    if (!this._showShortView) {
        $(document.getElementById(this.InstanceName + "_SearchTextBox")).removeClass('Active');
    }
    $(document.getElementById(this.InstanceName + "_ImgDelValue")).removeClass('Active');
    this.DropDownJQDisplayParent.css("display", "none");
}

searchBarJSP._render = function () {
    if (this._parentNode) {
        var self = this;

        var iHtml = "";
        if (this._showShortView) {
            iHtml = this._getInnerHTMLShort();
        }
        else {
            iHtml = this._getInnerHTML();
        }
        this._parentNode.innerHTML = iHtml;

        document.getElementById(this.InstanceName + "_SearchTextBox").onclick = function () { self._onActivateSearchString(); $(document.getElementById(self._textBoxID)).focus(); };
        if (!this._showShortView) {
            document.getElementById(this._textBoxID).onfocus = function () { self._onActivateSearchString(); };
        }
        document.getElementById(this._textBoxID).onblur = function () { self._onBlurSearchString(); };

        document.getElementById(this.InstanceName + "_ImgDelValue").onclick = function () { self._DelValueforSearchString(self); };
        document.getElementById(this.InstanceName + "_ImgDelValue").onmousedown = function () { $(this).addClass('Active'); };
        document.getElementById(this.InstanceName + "_ImgDelValue").onmouseup = function () { $(this).removeClass('Active'); };
        document.getElementById(this.InstanceName + "_ImgDelValue").onmouseout = function () { $(this).removeClass('Active'); this.setAttribute("prCursor", "0"); };
        document.getElementById(this.InstanceName + "_ImgDelValue").onmouseover = function () { this.setAttribute("prCursor", "1"); };

        if ((typeof document.getElementById("SBSearchBottomWithArr") != "undefined") && (document.getElementById("SBSearchBottomWithArr") != null)) {
            document.getElementById("SBSearchBottomWithArr").onclick = function () { od.SearchManager._setAnimationForKAPPanel(this); };
            document.getElementById("SBSearchBottomWithArr").onmousedown = function () { $(document.getElementById("SBSearchBottomWithArrDiv")).addClass('Active'); };
            document.getElementById("SBSearchBottomWithArr").onmouseup = function () { $(document.getElementById("SBSearchBottomWithArrDiv")).removeClass('Active'); };
            document.getElementById("SBSearchBottomWithArr").onmouseout = function () { $(document.getElementById("SBSearchBottomWithArrDiv")).removeClass('Active'); };
        }

        var id_suffix = "";        
        if (this._showShortView) {
            id_suffix = "Short";
        }

        var button_v = "";
        var CenterFilletBlockParam = {
            widthLeftLine: 9,
            widthRightLine: 9,
            contentText: "<div class='SearchButtonMainContent " + id_suffix + "'>{Content}</div>",
            idPrefix: "SearchBarSearchButtonC" + id_suffix
        };
        btn = new Design.CenterFilletBlockMaster(CenterFilletBlockParam);
        button_v = btn.resultSTR;

        var button_height = 43;
        var button_width = 117;
        if (this._showShortView) {
            button_height = 32;
            button_width = 81;
        }

        var SearchButton = new PP.Ui.Button({
            ParentNode: document.getElementById(this.InstanceName + "_btnSearchDiv"),
            Content: "Найти",
            Width: button_width,
            Height: button_height,
            Template: button_v,
            Click: function () {
                ////////debugger;;
                iascore.StartProgress();
                $.cookie("ownerId", "");
                od.SearchManager.StartSearch(true);
            }
        });
        SearchButton.addClass("SearchButton");
        if (id_suffix != "") {
            SearchButton.addClass(id_suffix);
        }

        var caption_for_check_doc = "Поиск по документам";
        var caption_for_check_fact = "Поиск по статистике";
        if (this._showShortView) {
            caption_for_check_doc = "Документы";
            caption_for_check_fact = "Статистика";
        }

        this._filterParamDocument = new PP.Ui.CheckBox({
            ParentNode: document.getElementById(this._docFilterParamHolderID),
            Checked: true,
            Content: caption_for_check_doc,
            CheckedChanged: function () {
                self._setFilterValue();
            }
        });
        this._filterParamDocument.addClass("SearchBarTextBox");
        if (id_suffix != "") {
            this._filterParamDocument.addClass(id_suffix);
        }

        this._filterParamFactor = new PP.Ui.CheckBox({
            ParentNode: document.getElementById(this._factorFilterParamHolderID),
            Checked: true,
            Content: caption_for_check_fact,
            CheckedChanged: function () {
                self._setFilterValue();
            }
        });
        this._filterParamFactor.addClass("SearchBarTextBox");
        if (id_suffix != "") {
            this._filterParamFactor.addClass(id_suffix);
        }

        this.UserHistoryLink = document.getElementById(this._userHistoryLinkID);
        this._advancedLink = document.getElementById(this._advancedLinkID);
        this._sideLinksHolder = document.getElementById(this._sideLinksHolderID);
        this._awContent = document.getElementById(this._awContentID);

        this.UserHistoryLink.style.position = "relative";
        this.UserHistoryLink.style.top = "0";
        this.UserHistoryLink.style.right = "0";
        //отключаем расширенный поиск
        //this._advancedLink.onclick = function () { self.ShowAdvancedWindow(); };
    }
};

searchBarJSP.ShowAdvancedFilter = function (isShow) {
    this._needShowAdvancedFilter = isShow;
    document.getElementById(this._advancedFilterHolderID).style.display = isShow ? "block" : "none";
};

searchBarJSP.getCaseForDocument = function (_cnt) {
    var docCaption = "";
    var docCountStr = _cnt;
    var docCountSuffix = docCountStr.length >= 2
                        ? parseInt(docCountStr.substr(docCountStr.length - 2, 2))
                        : parseInt(docCountStr.substr(docCountStr.length - 1, 1));

    if (docCountSuffix >= 10 && docCountSuffix <= 20) {
        docCaption = "документов";
    }
    else {
        docCountSuffix = parseInt(docCountStr.substr(docCountStr.length - 1, 1));
        switch (docCountSuffix) {
            case 1:
                docCaption = "документ";
                break;
            case 2:
            case 3:
            case 4:
                docCaption = "документа";
                break;
            default:
                docCaption = "документов";
                break;

        }
    }

    return docCaption;
};

searchBarJSP.getCaseForFile = function (_cnt) {
    var docCaption = "";
    var docCountStr = _cnt;
    var docCountSuffix = docCountStr.length >= 2
                        ? parseInt(docCountStr.substr(docCountStr.length - 2, 2))
                        : parseInt(docCountStr.substr(docCountStr.length - 1, 1));

    if (docCountSuffix >= 10 && docCountSuffix <= 20) {
        docCaption = "файлов";
    }
    else {
        docCountSuffix = parseInt(docCountStr.substr(docCountStr.length - 1, 1));
        switch (docCountSuffix) {
            case 1:
                docCaption = "файл";
                break;
            case 2:
            case 3:
            case 4:
                docCaption = "файла";
                break;
            default:
                docCaption = "файлов";
                break;

        }
    }

    return docCaption;
};

searchBarJSP.getCaseForSearch = function (_cnt) {
    var factCaption = ""; 
    var factCountStr = _cnt;
    var factCountSuffix = factCountStr.length >= 2
                        ? parseInt(factCountStr.substr(factCountStr.length - 2, 2))
                        : parseInt(factCountStr.substr(factCountStr.length - 1, 1));

    if (factCountSuffix >= 10 && factCountSuffix <= 20) {
        factCaption = "Найдено";
    }
    else {
        factCountSuffix = parseInt(factCountStr.substr(factCountStr.length - 1, 1));
        switch (factCountSuffix) {
            case 1:
                factCaption = "Найден";
                break;
            default:
                factCaption = "Найдено";
                break;

        }
    }

    return factCaption;
};

searchBarJSP.getCaseForFactor = function (_cnt) {
    var factCaption = "";
    var factCountStr = _cnt;
    var factCountSuffix = factCountStr.length >= 2
                        ? parseInt(factCountStr.substr(factCountStr.length - 2, 2))
                        : parseInt(factCountStr.substr(factCountStr.length - 1, 1));

    if (factCountSuffix >= 10 && factCountSuffix <= 20) {
        factCaption = "наборов данных";
    }
    else {
        factCountSuffix = parseInt(factCountStr.substr(factCountStr.length - 1, 1));
        switch (factCountSuffix) {
            case 1:
                factCaption = "набор данных";
                break;
            case 2:
            case 3:
            case 4:
                factCaption = "набора данных";
                break;
            default:
                factCaption = "наборов данных";
                break;

        }
    }

    return factCaption;
};

searchBarJSP._setAnimationForKAPPanel = function (sender) {
    document.getElementById("SBSearchBottomWithArr").style.cursor = 'default';            
    var h = document.getElementById("SBSearchCenterWithKAPContent").offsetHeight;
    if (h == 0) {
        $("#SBSearchCenterWithKAPContent").slideDown(500, function () {
            $(document.getElementById("SBSearchBottomWithArrDiv")).removeClass('BottomArrow');
            $(document.getElementById("SBSearchBottomWithArrDiv")).addClass('TopArrow');
            document.getElementById("SBSearchBottomWithArr").style.cursor = 'pointer';            
        });
    }
    else {
        $("#SBSearchCenterWithKAPContent").slideUp(500, function () {
            $(document.getElementById("SBSearchBottomWithArrDiv")).removeClass('TopArrow');
            $(document.getElementById("SBSearchBottomWithArrDiv")).addClass('BottomArrow');
            document.getElementById("SBSearchBottomWithArr").style.cursor = 'pointer';                    
        });
    }
};

searchBarJSP._getInnerHTMLShort = function () {
    var parentTopDiv = document.createElement("DIV");
    parentTopDiv.id = "SBShortSearchTopWithSearch";

    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    var result = "";

    var SBContainer = document.createElement("DIV");
    SBContainer.className = "SBContainer Short";

    var SBSearchAndButton = document.createElement("DIV");
    SBSearchAndButton.style.cssText = "position: relative; width: 431px;";
    SBContainer.appendChild(SBSearchAndButton);

    var SBCaptionSearchDiv = document.createElement("DIV");
    SBCaptionSearchDiv.id = this.InstanceName + "_CaptionSB";
    SBCaptionSearchDiv.innerHTML = "Портал открытых данных";
    SBSearchAndButton.appendChild(SBCaptionSearchDiv);

    var SBOnlySearchDiv = document.createElement("DIV");
    SBOnlySearchDiv.id = this.InstanceName + "_SearchTextBox";
    SBOnlySearchDiv.className = "Active";
    SBSearchAndButton.appendChild(SBOnlySearchDiv);

    var TopSearchBlock = {
        widthLeftCorner: 5,
        widthRightCorner: 5,
        height: 6,
        parentHolder: SBOnlySearchDiv,
        idPrefix: this.InstanceName + "_Top"
    };
    new Design.TopFilletBlockMaster(TopSearchBlock);

    var CenterSearchBlockContentInput = document.createElement("INPUT");
    CenterSearchBlockContentInput.type = "text";
    CenterSearchBlockContentInput.id = this._textBoxID;
    CenterSearchBlockContentInput.className = "txtFind Short";
    CenterSearchBlockContentInput.value = "";
    CenterSearchBlockContentInput.maxlength = 255;
    CenterSearchBlockContentInput.style.cssText = "z-index: 50; width: 395px;";

    var CenterSearchBlockContent = document.createElement("DIV");
    CenterSearchBlockContent.className = "txtFindParentNode";
    CenterSearchBlockContent.style.cssText = "height: 16px; margin-left: 5px; margin-right: 5px; text-align: left;";
    CenterSearchBlockContent.appendChild(CenterSearchBlockContentInput);

    var CenterSearchBlockDelValueImg = document.createElement("div");
    CenterSearchBlockDelValueImg.id = this.InstanceName + "_ImgDelValue";
    CenterSearchBlockDelValueImg.setAttribute("prCursor", "0");
    CenterSearchBlockDelValueImg.className = "ImgDelValue Short";
    CenterSearchBlockDelValueImg.title = "Удалить";
    CenterSearchBlockContent.appendChild(CenterSearchBlockDelValueImg);

    var CenterSearchBlock = {
        widthLeftLine: 4,
        widthRightLine: 4,
        contentHolder: CenterSearchBlockContent,
        parentHolder: SBOnlySearchDiv,
        idPrefix: this.InstanceName,
        classForLeftLine: "Short",
        classForRightLine: "Short",
        classForBackgroundColor: "Short"
    };
    new Design.CenterFilletBlockMaster(CenterSearchBlock);

    var BottomSearchBlock = {
        widthLeftCorner: 5,
        widthRightCorner: 5,
        height: 5,
        parentHolder: SBOnlySearchDiv,
        idPrefix: this.InstanceName + "_Bottom"
    };
    new Design.TopFilletBlockMaster(BottomSearchBlock);

    var SBSearchDropDownParentDisplay = document.createElement("DIV");
    SBSearchDropDownParentDisplay.id = this._dropDownIDDisplayParent;
    SBSearchDropDownParentDisplay.className = "txtFindDropDownParentDisplay Short";
    SBSearchDropDownParentDisplay.style.cssText = "display: none;";
    SBSearchAndButton.appendChild(SBSearchDropDownParentDisplay);

    var TopDropDownSearchBlock = {
        widthLeftCorner: 8,
        widthRightCorner: 8,
        height: 2,
        parentHolder: SBSearchDropDownParentDisplay,
        classForLeftCorner: "DropDownLeftTopCorner",
        classForRightCorner: "DropDownRightTopCorner",
        classForLine: "DropDownTopLine"
    };
    new Design.TopFilletBlockMaster(TopDropDownSearchBlock);

    var SBSearchDropDown = document.createElement("DIV");
    SBSearchDropDown.style.cssText = "min-width: 429px; min-height: 34px;";
    SBSearchDropDown.innerHTML = "<div class=\"txtFindDropDownItem NotActive\"><div class=\"Line LeftLine Single\"></div><div class=\"Line RightLine Single\"></div><div class=\"SearchTxt\"></div></div>";
    SBSearchDropDown.id = this._dropDownID;

    var CenterDropDownSearchBlock = {
        widthLeftLine: 3,
        widthRightLine: 3,
        backgroundColor: "transparent",
        contentHolder: SBSearchDropDown,
        parentHolder: SBSearchDropDownParentDisplay,
        classForLeftLine: "DropDownLeftLine",
        classForRightLine: "DropDownRightLine"
    };
    new Design.CenterFilletBlockMaster(CenterDropDownSearchBlock);

    var BottomDropDownSearchBlock = {
        widthLeftCorner: 8,
        widthRightCorner: 8,
        height: 4,
        parentHolder: SBSearchDropDownParentDisplay,
        classForLeftCorner: "DropDownLeftBottomCorner",
        classForRightCorner: "DropDownRightBottomCorner",
        classForLine: "DropDownBottomLine"
    };
    new Design.TopFilletBlockMaster(BottomDropDownSearchBlock);

    var SBSearchDivButton = document.createElement("DIV");
    SBSearchDivButton.id = this.InstanceName + "_btnSearchDiv";
    SBSearchDivButton.style.cssText = "position: absolute; top: -3px; right: -89px;";
    SBSearchAndButton.appendChild(SBSearchDivButton);

    result += "<div class=\"SBStatsHolder\">";

    //согласно шаблону добавляем строку с фильтрацией
    result += "<div id=\"" + this._statsAndFilterParamHolderID + "\" class=\"SBStatsAndFilterParam Short\">";
    result += "<table cellpadding='0' cellspacing='0'>";
    result += "<tr>";
    result += "<td><div id=\"" + this._docFilterParamHolderID + "\" style=\"margin-right: 148px;\"></div></td>";
    result += "<td><div style=\"position: relative;\"><div class=\"SBStatsText Short Doc\"><div class=\"LinkFilter\" onfocus=\"this.blur();\" onclick=\"od.SearchManager.SearchAllDocuments();\">(" + this._countDocument + ")</div></div></div></td>";
    result += "<td><div id=\"" + this._factorFilterParamHolderID + "\" style=\"margin-right: 150px;\"></div></td>";
    result += "<td><div style=\"position: relative;\"><div class=\"SBStatsText Short Fact\"><div class=\"LinkFilter\" onfocus=\"this.blur();\" onclick=\"od.SearchManager.SearchAllFactors();\">(" + this._countFactor + ")</div></div></div></td>";
    result += "</tr>";
    result += "</table>";
    result += "</div>";

    result += "</div>";

    result += "<div id=\"" + this._awContentID + "\" style=\"display: none; background-color: #FFF; padding: 0 55px 35px 53px;\">";

    result += "<div class=\"SBOptionsHolder\">";
    result += "<div id=\"" + this._resultsFilterHolderID + "\" style=\"display: " + (this._needShowResultsFilter ? "block" : "none") + ";\"></div>";
    result += "<div id=\"" + this._searchOptionsHolderID + "\" style=\"display: " + (this._needShowSearchOptions ? "block" : "none") + "; position:relative; margin-bottom: 8px;\"></div>";
    result += "<div id=\"" + this._advancedFilterHolderID + "\" style=\"display: " + (this._needShowAdvancedFilter ? "block" : "none") + "; position:relative; margin-bottom: 10px;\"></div>";
    result += "<div id=\"" + this._dateOptionsHolderID + "\" style=\"display: " + (this._needShowDateOptions ? "block" : "none") + "; position:relative; margin-bottom: 10px;\"></div>";
    result += "<div id=\"" + this._sortOptionsHolderID + "\" style=\"display: " + (this._needShowSortOptions ? "block" : "none") + ";\"></div>";
    result += "<div id=\"" + this._searchButtonsHolderID + "\"></div>";
    result += "</div>";

    result += "</div>";

    result += "<div id=\"" + this._sideLinksHolderID + "\" style=\"position: relative;\">";
    result += "<div class=\"SBHistoryLink\" id=\"" + this._userHistoryLinkID + "\" onfocus=\"this.blur();\" style=\"display: none;\">История поиска</div>";
    //отключаем расширенный поиск
    //result += "<div class=\"SBHistoryLink Short\" id=\"" + this._advancedLinkID + "\" onfocus=\"this.blur();\" style=\"display: none;\">Расширенный поиск</div>";
    result += "</div>";

    SBContainer.innerHTML = SBContainer.innerHTML + result;

    parentTopDiv.innerHTML = SBContainer.outerHTML;

    return parentTopDiv.outerHTML;
};

searchBarJSP._getInnerHTML = function () {
    var parentTopDiv = document.createElement("DIV");
    parentTopDiv.id = "SBSearchTopWithSearch";

    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    var result = "";

    var SBContainer = document.createElement("DIV");
    SBContainer.className = "SBContainer";

    var SBSearchAndButton = document.createElement("DIV");
    SBSearchAndButton.style.cssText = "position: relative; width: 762px";
    SBContainer.appendChild(SBSearchAndButton);

    var SBOnlySearchDiv = document.createElement("DIV");
    SBOnlySearchDiv.id = this.InstanceName + "_SearchTextBox";
    SBSearchAndButton.appendChild(SBOnlySearchDiv);

    var TopSearchBlock = {
        widthLeftCorner: 5,
        widthRightCorner: 5,
        height: 6,
        parentHolder: SBOnlySearchDiv,
        idPrefix: this.InstanceName + "_Top"
    };
    new Design.TopFilletBlockMaster(TopSearchBlock);

    var CenterSearchBlockContentInput = document.createElement("INPUT");
    CenterSearchBlockContentInput.type = "text";
    CenterSearchBlockContentInput.id = this._textBoxID;
    CenterSearchBlockContentInput.className = "txtFind";
    CenterSearchBlockContentInput.value = "";
    CenterSearchBlockContentInput.maxlength = 255;
    CenterSearchBlockContentInput.style.cssText = "z-index: 50; width: 720px;";

    var CenterSearchBlockContent = document.createElement("DIV");
    CenterSearchBlockContent.className = "txtFindParentNode";
    CenterSearchBlockContent.style.cssText = "height: 27px; margin-left: 7px; margin-right: 7px;";
    CenterSearchBlockContent.appendChild(CenterSearchBlockContentInput);

    var CenterSearchBlockDelValueImg = document.createElement("div");
    CenterSearchBlockDelValueImg.id = this.InstanceName + "_ImgDelValue";
    CenterSearchBlockDelValueImg.setAttribute("prCursor", "0");
    CenterSearchBlockDelValueImg.className = "ImgDelValue";
    CenterSearchBlockDelValueImg.style.cssText = "display: none;";
    CenterSearchBlockDelValueImg.title = "Удалить";
    CenterSearchBlockContent.appendChild(CenterSearchBlockDelValueImg);

    var CenterSearchBlock = {
        widthLeftLine: 4,
        widthRightLine: 4,
        contentHolder: CenterSearchBlockContent,
        parentHolder: SBOnlySearchDiv,
        idPrefix: this.InstanceName
    };
    new Design.CenterFilletBlockMaster(CenterSearchBlock);

    var BottomSearchBlock = {
        widthLeftCorner: 5,
        widthRightCorner: 5,
        height: 5,
        parentHolder: SBOnlySearchDiv,
        idPrefix: this.InstanceName + "_Bottom"
    };
    new Design.TopFilletBlockMaster(BottomSearchBlock);

    var SBSearchDropDownParentDisplay = document.createElement("DIV");
    SBSearchDropDownParentDisplay.id = this._dropDownIDDisplayParent;
    SBSearchDropDownParentDisplay.className = "txtFindDropDownParentDisplay";
    SBSearchDropDownParentDisplay.style.cssText = "display: none;";
    SBSearchAndButton.appendChild(SBSearchDropDownParentDisplay);

    var TopDropDownSearchBlock = {
        widthLeftCorner: 8,
        widthRightCorner: 8,
        height: 2,
        parentHolder: SBSearchDropDownParentDisplay,
        classForLeftCorner: "DropDownLeftTopCorner",
        classForRightCorner: "DropDownRightTopCorner",
        classForLine: "DropDownTopLine"
    };
    new Design.TopFilletBlockMaster(TopDropDownSearchBlock);

    var SBSearchDropDown = document.createElement("DIV");
    SBSearchDropDown.style.cssText = "min-width: 760px; min-height: 34px;";
    SBSearchDropDown.innerHTML = "<div class=\"txtFindDropDownItem NotActive\"><div class=\"Line LeftLine Single\"></div><div class=\"Line RightLine Single\"></div><div class=\"SearchTxt\"></div></div>";
    SBSearchDropDown.id = this._dropDownID;

    var CenterDropDownSearchBlock = {
        widthLeftLine: 3,
        widthRightLine: 3,
        backgroundColor: "transparent",
        contentHolder: SBSearchDropDown,
        parentHolder: SBSearchDropDownParentDisplay,
        classForLeftLine: "DropDownLeftLine",
        classForRightLine: "DropDownRightLine"
    };
    new Design.CenterFilletBlockMaster(CenterDropDownSearchBlock);

    var BottomDropDownSearchBlock = {
        widthLeftCorner: 8,
        widthRightCorner: 8,
        height: 4,
        parentHolder: SBSearchDropDownParentDisplay,
        classForLeftCorner: "DropDownLeftBottomCorner",
        classForRightCorner: "DropDownRightBottomCorner",
        classForLine: "DropDownBottomLine"
    };
    new Design.TopFilletBlockMaster(BottomDropDownSearchBlock);

    var SBSearchDivButton = document.createElement("DIV");
    SBSearchDivButton.id = this.InstanceName + "_btnSearchDiv";
    SBSearchDivButton.style.cssText = "position: absolute; top: -3px; right: -128px;";
    SBSearchAndButton.appendChild(SBSearchDivButton);

    result += "<div class=\"SBStatsHolder\">";

    //согласно шаблону добавляем строку с фильтрацией
    result += "<div id=\"" + this._statsAndFilterParamHolderID + "\" class=\"SBStatsAndFilterParam\">";
    result += "<table cellpadding='0' cellspacing='0'>";
    result += "<tr>";
    result += "<td><div id=\"" + this._docFilterParamHolderID + "\" style=\"margin-right: 150px; width: 186px;\"></div></td>";
    result += "<td><div style=\"position: relative;\"><div class=\"SBStatsText\"><div class=\"LinkFilter\" onfocus=\"this.blur();\" onclick=\"od.SearchManager.SearchAllDocuments();\">(" + this._countDocument + " " + this.getCaseForFile(this._countDocument) + ")</div></div></div></td>";
    result += "<td><div id=\"" + this._factorFilterParamHolderID + "\" style=\"margin-right: 150px; width: 178px;\"></div></td>";
    result += "<td><div style=\"position: relative;\"><div class=\"SBStatsText\"><div class=\"LinkFilter\" onfocus=\"this.blur();\" onclick=\"od.SearchManager.SearchAllFactors();\">(" + this._countFactor + " " + this.getCaseForFactor(this._countFactor) + ")</div></div></div></td>";
    result += "</tr>";
    result += "</table>";
    result += "</div>";

    result += "</div>";

    result += "<div id=\"" + this._awContentID + "\" style=\"display: none; background-color: #FFF; padding: 0 55px 35px 53px;\">";

    result += "<div class=\"SBOptionsHolder\">";
    result += "<div id=\"" + this._resultsFilterHolderID + "\" style=\"display: " + (this._needShowResultsFilter ? "block" : "none") + ";\"></div>";
    result += "<div id=\"" + this._searchOptionsHolderID + "\" style=\"display: " + (this._needShowSearchOptions ? "block" : "none") + "; position:relative; margin-bottom: 8px;\"></div>";
    result += "<div id=\"" + this._advancedFilterHolderID + "\" style=\"display: " + (this._needShowAdvancedFilter ? "block" : "none") + "; position:relative; margin-bottom: 10px;\"></div>";
    result += "<div id=\"" + this._dateOptionsHolderID + "\" style=\"display: " + (this._needShowDateOptions ? "block" : "none") + "; position:relative; margin-bottom: 10px;\"></div>";
    result += "<div id=\"" + this._sortOptionsHolderID + "\" style=\"display: " + (this._needShowSortOptions ? "block" : "none") + ";\"></div>";
    result += "<div id=\"" + this._searchButtonsHolderID + "\"></div>";
    result += "</div>";

    result += "</div>";

    result += "<div id=\"" + this._sideLinksHolderID + "\" style=\"position: relative;\">";
    result += "<div class=\"SBHistoryLink\" id=\"" + this._userHistoryLinkID + "\" onfocus=\"this.blur();\" style=\"display: none;\">История поиска</div>";
    //отключаем расширенный поиск
    //result += "<div class=\"SBHistoryLink\" id=\"" + this._advancedLinkID + "\" onfocus=\"this.blur();\" style=\"display: none;\">Расширенный поиск</div>";
    result += "</div>";

    SBContainer.innerHTML = SBContainer.innerHTML + result;

    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

    parentTopDiv.innerHTML = SBContainer.outerHTML;

    var parentCenterDiv = document.createElement("DIV");
    parentCenterDiv.id = "SBSearchCenterWithKAP";

    var parentCenterDivContent = document.createElement("DIV");
    parentCenterDivContent.id = "SBSearchCenterWithKAPContent";

    var CenterFilletBlockParam = {
        pathForLeftLine: od.pageCorrector + "Images/SearchBar/MainBlockWithKAP/left_right_line.png",
        positionForLeftLine: "0 0",
        pathForRightLine: od.pageCorrector + "Images/SearchBar/MainBlockWithKAP/left_right_line.png",
        positionForRightLine: "-2px 0",
        widthLeftLine: 2,
        widthRightLine: 2,
        backgroundColor: "#FFF",
        contentHolder: parentCenterDivContent,
        parentHolder: parentCenterDiv
    };
    new Design.CenterFilletBlockMaster(CenterFilletBlockParam);

    var parentBottomDiv = document.createElement("DIV");
    parentBottomDiv.id = "SBSearchBottomWithArr";

    var parentBottomDivContent = document.createElement("DIV");
    parentBottomDivContent.id = "SBSearchBottomWithArrContent";
    parentBottomDivContent.align = "center";

    var parentBottomDivDiv = document.createElement("DIV");
    parentBottomDivContent.appendChild(parentBottomDivDiv);
    parentBottomDivDiv.id = "SBSearchBottomWithArrDiv";
    parentBottomDivDiv.className = "SBSearchBottomWithArrDiv TopArrow";

    var CenterFilletBlockParam = {
        widthLeftLine: 8,
        widthRightLine: 8,
        contentHolder: parentBottomDivContent,
        parentHolder: parentBottomDiv,
        idPrefix: "SBSearchBottomWithArrC"
    };
    new Design.CenterFilletBlockMaster(CenterFilletBlockParam);

    return parentTopDiv.outerHTML + parentCenterDiv.outerHTML + parentBottomDiv.outerHTML;
};

searchBarJSP._createAdvancedWindow = function () {
    this._advancedWindow = new iascore.ModalWindow({
        Width: 865,
        MarginTop: 22
    });
};

searchBarJSP.SetStatisticsText = function (text) {
    if (this.StatsHolder) {
        this.StatsHolder.innerHTML = text;
    }
};

searchBarJSP.ShowUserHistoryLink = function (isShow) {
    this.UserHistoryLink.style.display = isShow ? "inline-block" : "none";
};

searchBarJSP.ShowAdvancedLink = function (isShow) {
    //отключаем расширенный поиск
    //this._advancedLink.style.display = isShow ? "block" : "none";
};

searchBarJSP.ShowAdvancedWindow = function () {
    iascore.StartProgress();
    this._initTempObjForSearchParams();
    this._createAdvancedWindow();
    this._advancedWindow.setContent("Расширенный поиск", this._awContent);
    this._advancedWindow.setTitleMarginBottom(28);
    this._awContent.style.display = "block";
    this._advancedWindow.show();
    iascore.StopProgress();
};

searchBarJSP.SetDateOptionValueUI = function (value) {
    var self = this;
    this.DateOptionValue = value;
    if (this.ResultsViewer) {
        this.ResultsViewer.DateSelectorValue = value;
    }

};

searchBarJSP = null;
