﻿if (typeof od.searchengine == "undefined") od.searchengine = new Object();

od.searchengine.ResultsViewer =
function (resultsHolderID, pageSelectorHolderID, resultsStatsHolderID, sortComboHolderID, searchBar) {
    this.SearchBar = searchBar;
    this.FindString = "";
    this.DateSelectorValue = od.searchengine.DateOption.All;
    this.PageSize = 10;
    this.PageCount = 0;
    this.CurrentPage = -1;
    this.SelectedPage = -1;
    this.ResultsHolder = document.getElementById(resultsHolderID)
        ? document.getElementById(resultsHolderID)
        : null;
    this.PageSelectorHolder = document.getElementById(pageSelectorHolderID)
        ? document.getElementById(pageSelectorHolderID)
        : null;
    this.ResultsStatsHolder = document.getElementById(resultsStatsHolderID)
        ? document.getElementById(resultsStatsHolderID)
        : null;
    this.SortComboHolder = document.getElementById(sortComboHolderID)
        ? document.getElementById(sortComboHolderID)
        : null;
    
    this.ResultsFilterValue = od.searchengine.ResultsFilter.All;
    this.SortOptionValue = od.searchengine.SortOption.Date;//по умолчанию по дате изменения сортировка
    this.SortOptionDopValue = od.searchengine.SortOptionDop.Fact;//по умолчанию по показателям только
    this.SearchOptionValue = od.searchengine.SearchOption.Extended;
    //this.AdvancedFilterPopularElementValue = od.searchengine.AdvancedFilterPopularElement.All;
    this.AdvancedFilterFavoriteElementValue = od.searchengine.AdvancedFilterFavoriteElement.All;
    this.AdvancedFilterCommentElementValue = od.searchengine.AdvancedFilterCommentElement.All;
    this.FirstPageLoaded = false;
    this.ForReestr = false;

    this.ShowSocialButtons = false;
    this.ShowRatings = true;
    this.ShowFavouritesLinks = true;
    this.ShowDataMartLinks = true;
    this.ShowDataItemSelectorLinks = false;
    this.ShowCommentsLinks = true;
    this.ShowSearchWord = true;

    this.ShortOutput = false;
    this.NeedClearPageResult = true;
    this.ClearType = "";
    this.UserProfileID = "-1";
    this.NeedSaveSession = true;
    this.DirectionID = "-1";
    this.fromMain = false;

    this.AfterSearchRequestComlete = function () { };

    this.PollID = -1; // ID соцопроса для взаимодействия с od.DataItemSelector
};

od.searchengine.ResultsViewer.prototype = {

    StartSearch: function (saveRequest, topCnt, callback) {
        this.SelectedPage = -1;
        this.CurrentPage = 0;
        this.NeedClearPageResult = true;
        this.SearchRequestSend(true, saveRequest, topCnt, callback);
    },

    ViewPage: function (pageIDX) {
        this.CurrentPage = pageIDX;
        this.SearchRequestSend(false, false);
    },

    ViewPageExt: function (elem) {
        this.CurrentPage = parseInt(elem.getAttribute("IDX"));
        this.SearchRequestSend(false, false);
    },

    PageNext: function () {
        //debugger;
        if (this.PageCount > this.SelectedPage) {
            this.NeedClearPageResult = false;
            this.ViewPage(this.CurrentPage + 1);
        }
    },

    PagePrev: function () {
        //debugger;
        if (this.SelectedPage > 0) {
            this.ViewPage(this.CurrentPage - 1);
        }
    },

    PageReload: function () {
        //debugger;
        if (this.SelectedPage >= 0) {
            this.ViewPage(this.CurrentPage);
        }
    },

    SearchRequestSend: function (isNewRequest, NeedSave, topCnt, callback) {        
        var AdvancedFilterAllElement = 0;
        if (this.FindString != "") {
            AdvancedFilterAllElement = 1;
        }

        var httpRequestUrl = od.pageCorrector + "SearchEngine/HSEGetResults.ashx";

        var buttonOptions = "";
        buttonOptions += this.ShowSocialButtons ? "1" : "0";
        buttonOptions += this.ShowRatings ? "1" : "0";
        buttonOptions += this.ShowFavouritesLinks ? "1" : "0";
        buttonOptions += this.ShowDataMartLinks ? "1" : "0";
        buttonOptions += this.ShowDataItemSelectorLinks ? "1" : "0";
        buttonOptions += this.ShowCommentsLinks ? "1" : "0";
        
        if (filterDirection != undefined && filterDirection != null)
        {
            this.DirectionID = filterDirection.key;
        }

        //debugger;

        var findStr = ($("#sbMainSearch_txtFind").val().length > 0) ? $("#sbMainSearch_txtFind").val() : this.FindString;
        findStr = findStr.replace(/;/g, "").replace(/=/g, "");
        if (findStr.length > 0) this.ShortOutput = false;
        var postData =
                    "NEW=" + (isNewRequest ? "1" : "0") +
                    ";P=" + this.CurrentPage +
                    ";PS=" + this.PageSize +
                    ";QS=" + (NeedSave ? "1" : "0") +
                    ";QSSES=" + (this.NeedSaveSession ? "1" : "0") +
                    ";SHO=" + (this.ShortOutput ? "1" : "0") +
                    ";FS=" + findStr +
                    ";FLT=" + this.ResultsFilterValue +
                    ";SO=" + this.SortOptionValue +
                    ";SOD=" + this.SortOptionDopValue +
                    ";STP=" + this.SearchOptionValue + //ставив 0 чтоб искать только по наименованию
                    ";DT=" + this.DateSelectorValue +
                    ";BO=" + buttonOptions +
                    ";AFA=" + AdvancedFilterAllElement +
                    ";AFP=0" + //this.AdvancedFilterPopularElementValue +
                    ";AFF=" + this.AdvancedFilterFavoriteElementValue +
                    ";AFC=" + this.AdvancedFilterCommentElementValue +
                    ";POLL=" + this.PollID +
                    ";CLT=" + this.ClearType +
                    ";UPID=" + this.UserProfileID +
                    ";MAIN=" + this.fromMain +
                    ";DIR=" + this.DirectionID + 
                    ";TOPCOUNT=" + topCnt +
                    ";OWNERIOGV=" + this.OwnerKey;
        //debugger;
        var searchRequest = new iascore.RequestManager(postData, httpRequestUrl);
        searchRequest.Sender = this;
        if (this.ShortOutput) {
            searchRequest.RequestComplete = this.ShortSearchRequestComplete;
            
            if (callback)
                callback();
            else {
                try {
                    ShowHideAlldirectionDiv();
                } catch (e) { }
            }
        }
        else {
            searchRequest.RequestComplete = this.SearchRequestComplete;
            
            if (callback)
                callback();
            else {
                try
                {
                    ShowHideAlldirectionDiv();
                }catch(e){ }
            }
        }
        searchRequest.Send();
    },

    BaseSearchRequestComplete: function (selfinst, args) {
        //debugger;
        if (selfinst.ResultsHolder) {
            var contentParts = args;
            var htmlStartPos = contentParts.indexOf("<", 0);

            var statsParts = htmlStartPos > 0
                    ? contentParts.substr(0, htmlStartPos).split("#")
                    : contentParts.split("#");
            var html = htmlStartPos > 0
                    ? contentParts.substr(htmlStartPos, contentParts.length - htmlStartPos)
                    : "";

            var stats = {
                pageCount: 0,
                factCount: 0,
                docCount: 0,
                pollCount: 0,
                proposalCount: 0,
                countNextPageElement: 0
            };

            stats.pageCount = parseInt(statsParts[0]);
            stats.factCount = parseInt(statsParts[1]);
            stats.docCount = parseInt(statsParts[2]);
            stats.pollCount = parseInt(statsParts[3]);
            stats.proposalCount = parseInt(statsParts[4]);
            stats.countNextPageElement = parseInt(statsParts[9]);

            var txt_stat = "";

            if ((stats.factCount == 0) && (stats.docCount == 0)) {
                if (this.ShowSearchWord) {//вызвали не из личного кабинета
                    txt_stat = "Ничего не найдено";
                }
                else {//вызвали из личного кабинета, нужно понять откуда и вывести нужный текст
                    txt_stat = "Ничего не найдено";
                    if (this.AdvancedFilterFavoriteElementValue == od.searchengine.AdvancedFilterFavoriteElement.Favorite) {
                        txt_stat = "Избранного нет";
                    }
                    if (this.AdvancedFilterCommentElementValue == od.searchengine.AdvancedFilterCommentElement.Comment) {
                        txt_stat = "Комментариев нет";
                    }
                }
                if (this.SortComboHolder) {
                    this.SortComboHolder.style.display = "none";
                }
            }
            else {
                var txt_stat_doc = "";
                var txt_stat_fact = "";

                if (stats.docCount > 0) {
                    if (this.ShowSearchWord) {
                        txt_stat = (selfinst.SearchBar.getCaseForSearch != undefined) ? selfinst.SearchBar.getCaseForSearch(statsParts[2]) + " " : "";
                    }
                    else {
                        txt_stat = "";
                    }
                    txt_stat_doc = statsParts[6] + " " + selfinst.SearchBar.getCaseForDocument(statsParts[2]);
                }

                if (stats.factCount > 0) {
                    if (stats.docCount == 0) {
                        if (this.ShowSearchWord) {
                            txt_stat = (selfinst.SearchBar.getCaseForSearch != undefined) ? selfinst.SearchBar.getCaseForSearch(statsParts[1]) + " " : "";
                        }
                        else {
                            txt_stat = "";
                        }
                    }
                    txt_stat_fact = statsParts[5] + " " + selfinst.SearchBar.getCaseForFactor(statsParts[1]);
                }

                var comma = "";
                if ((stats.factCount > 0) && (stats.docCount > 0)) {
                    comma = " и ";
                }

                txt_stat = txt_stat + txt_stat_doc + comma + txt_stat_fact;

                if (this.SortComboHolder) {
                    this.SortComboHolder.style.display = "block";
                }
            }

            if (selfinst.ResultsStatsHolder)
            {
                selfinst.ResultsStatsHolder.innerHTML = "";
                selfinst.ResultsStatsHolder.innerHTML = txt_stat;
                selfinst.ResultsStatsHolder.style.display = "block";
            }            

            selfinst.BuildPageSelector(stats.pageCount, stats.countNextPageElement);

            // прячем элемент выбора 10 следующих, который не нужен
            if (stats.countNextPageElement <= 0) {
                $(".SearchResultsPageSelector").hide();
            } else {
                $(".SearchResultsPageSelector").show();
            }
            
            if (selfinst.NeedClearPageResult) {
                selfinst.ResultsHolder.innerHTML = "";
                if ((stats.factCount > 0) || (stats.docCount > 0)) {
                    selfinst.ResultsHolder.innerHTML = html;
                }
            }
            else {
                var tempElement = document.createElement('div');
                tempElement.innerHTML = html;
                var len = tempElement.childNodes.length;
                for (var i = 0; i <= len - 1; i++) {
                    selfinst.ResultsHolder.appendChild(tempElement.childNodes[0]);
                    
                }
                // вставлен костыль, т.к. что-то где-то не контачит вручную вставляем результат в блок
                if ($("#NewDataSet_CenterHolder").length == 0) {
                    $("#SearchResultsDataSet.SearchResultsContent").append(html);
                }
            }

            selfinst.ResultsHolder.style.display = "block";
            if (!selfinst.FirstPageLoaded) selfinst.FirstPageLoaded = true;
            selfinst.AfterSearchRequestComlete();
            od.ResizerCommon.Resize();
        }
    },

    SearchRequestComplete: function (selfinst, args) {
        //debugger;
        selfinst.BaseSearchRequestComplete(selfinst, args);
        if (od.ProgressManager) {
            od.ProgressManager.NextValue();
        }
    },

    //вариант сокращенного списка, без звёздочек, ссылок и т.п.
    ShortSearchRequestComplete: function (selfinst, args) {
        //debugger;
        if (selfinst.ResultsHolder) {
            var contentParts = args;
            var htmlStartPos = contentParts.indexOf("<", 0);

            var statsParts = htmlStartPos > 0
                    ? contentParts.substr(0, htmlStartPos).split("#")
                    : contentParts.split("#");
            var html = htmlStartPos > 0
                    ? contentParts.substr(htmlStartPos, contentParts.length - htmlStartPos)
                    : "";

            if (selfinst.PageSelectorHolder) {
                var stats = {
                    pageCount: 0,
                    factCount: 0,
                    docCount: 0,
                    pollCount: 0,
                    proposalCount: 0,
                    countNextPageElement: 0
                };

                stats.pageCount = parseInt(statsParts[0]);
                stats.countNextPageElement = parseInt(statsParts[9]);

                selfinst.BuildPageSelector(stats.pageCount, stats.countNextPageElement);
            }

            if (selfinst.ResultsStatsHolder) {
                selfinst.ResultsStatsHolder.innerHTML = "(" + statsParts[5] + " " + selfinst.SearchBar.getCaseForFactor(statsParts[1]) + ")";
            }

            var tempElement = document.createElement('div');
            tempElement.innerHTML = html;
            var len = tempElement.childNodes.length;

            if ($("div#SearchResultsDataSet") != undefined)
            {
                if ($("div#SearchResultsDataSet").length > 0 && selfinst.CurrentPage == 0) {
                    $("div#SearchResultsDataSet").empty();
                    var div = document.createElement("div");
                    selfinst.ResultsHolder = div;
                    $(div).attr("id", "NewDataSet_CenterHolder").addClass("SBShortCenterHolder");
                    $("div#SearchResultsDataSet").append(div);
                }
            }            
            for (var i = 0; i <= len - 1; i++) {
                if (i == 0 && selfinst.ForReestr)
                    tempElement.childNodes[0].style.paddingTop = "15px";
                selfinst.ResultsHolder.appendChild(tempElement.childNodes[0]);
            }
            if ($("div#SearchResultsDataSet").find(selfinst.ResultsHolder).length == 0)
            {
                $("div#SearchResultsDataSet").empty();
                $("div#SearchResultsDataSet").append(selfinst.ResultsHolder);
            }

            od.ResizerCommon.Resize();
            if (od.ProgressManager) {
                od.ProgressManager.NextValue();
            }
        }
    },

    _getCaseNext: function (countNextPageElement) {
        var factCaption = "";
        var factCountStr = countNextPageElement.toString();
        var factCountSuffix = factCountStr.length >= 2
                        ? parseInt(factCountStr.substr(factCountStr.length - 2, 2))
                        : parseInt(factCountStr.substr(factCountStr.length - 1, 1));

        if (factCountSuffix >= 10 && factCountSuffix <= 20) {
            factCaption = "следующие " + countNextPageElement + " результатов";
        }
        else {
            factCountSuffix = parseInt(factCountStr.substr(factCountStr.length - 1, 1));
            switch (factCountSuffix) {
                case 1:
                    factCaption = "следующий " + countNextPageElement + " результат";
                    break;
                case 2:
                case 3:
                case 4:
                    factCaption = "следующие " + countNextPageElement + " результата";
                    break;
                default:
                    factCaption = "следующие " + countNextPageElement + " результатов";
                    break;
            }
        }

        return factCaption;
    },

    BuildPageSelector: function (pageCountNew, countNextPageElement) {
        //debugger;
        var leftIDX = this.CurrentPage > 5
            ? this.CurrentPage - 5
            : 0;
        var rightIDX = (leftIDX + 9) < pageCountNew
            ? leftIDX + 9
            : pageCountNew - 1;

        //если кнопки ещё нет, то создаём её
        if (this.PageSelectorHolder != undefined)
        {
            if (!this.PageSelectorHolder.childNodes[0]) {
                var self = this;
                var selectorParentDiv = document.createElement("div");
                selectorParentDiv.className = "PageSelector";
                selectorParentDiv.onclick = function () { iascore.StartProgress(); self.PageNext(); };
                selectorParentDiv.onmousedown = function () { $(this).addClass('Active'); };
                selectorParentDiv.onmouseup = function () { $(this).removeClass('Active'); };
                selectorParentDiv.onmouseout = function () { $(this).removeClass('Active'); };
                this.PageSelectorHolder.appendChild(selectorParentDiv);

                var selectorDiv = document.createElement("div");
                selectorDiv.id = "PageSelectorContent";
                selectorDiv.className = "PageSelectorContent";

                var CenterFilletBlockParam = {
                    widthLeftLine: 8,
                    widthRightLine: 8,
                    contentHolder: selectorDiv,
                    parentHolder: selectorParentDiv,
                    classForLeftLine: "PageSelectorLeftLine",
                    classForRightLine: "PageSelectorRightLine",
                    classForBackgroundColor: "PageSelectorCenterBlock"
                };
                new Design.CenterFilletBlockMaster(CenterFilletBlockParam);
            }
        }        

        var needRebuild = (pageCountNew == 0) || (pageCountNew != this.PageCount);

        if (needRebuild) {
            this.PageCount = pageCountNew;
        }

        if ((this.CurrentPage == rightIDX) || (countNextPageElement == -10)) {
            if (this.PageSelectorHolder)
            {
                this.PageSelectorHolder.childNodes[0].style.display = "none";
                this.PageSelectorHolder.style.display = "none";
            }            
        }
        else if (countNextPageElement > 0) {
            document.getElementById("PageSelectorContent").innerHTML = "Загрузить " + this._getCaseNext(countNextPageElement);
            if (this.PageSelectorHolder != undefined)
            {
                this.PageSelectorHolder.childNodes[0].style.display = "inline-block";
                this.PageSelectorHolder.style.display = "block";
            }            
        }

        this.SelectedPage = this.CurrentPage;

    }

};


od.searchengine.DateSelector = function (holderID) {
    this.ParentControl = document.getElementById(holderID);
    this.WeekLink = null;
    this.MonthLink = null;
    this.DatePicker = null;
    this.ResultsViewer = null;

    this._init();
};

od.searchengine.DateSelector.prototype = {
    _init: function () {
        if (this.ParentControl) {
            var self = this;

            var weekHolder = document.createElement("div");
            weekHolder.style.marginBottom = "2px";
            this.ParentControl.appendChild(weekHolder);

            this.WeekLink = document.createElement("a");
            weekHolder.appendChild(this.WeekLink);

            this.WeekLink.innerHTML = "За последнюю неделю";
            this.WeekLink.className = "SBDatePickerLink";
            this.WeekLink.href = "javascript:void(0);";
            this.WeekLink.onfocus = function () {
                this.blur();
            };
            this.WeekLink.onclick = function () {
                self.ResultsViewer.SearchBar.SetText("");
                self.SearchBar.SetDateOptionValueUI(od.searchengine.DateOption.LastWeek);
                self.SearchBar.SetSearchOptionValue(od.searchengine.SearchOption.Extended);
                self.ResultsViewer.SearchBar.StartSearch(false);
            };

            var monthHolder = document.createElement("div");
            monthHolder.style.marginBottom = "2px";
            this.ParentControl.appendChild(monthHolder);

            this.MonthLink = document.createElement("a");
            monthHolder.appendChild(this.MonthLink);

            this.MonthLink.innerHTML = "За последний месяц";
            this.MonthLink.className = "SBDatePickerLink";
            this.MonthLink.href = "javascript:void(0);";
            this.MonthLink.onfocus = function () {
                this.blur();
            };
            this.MonthLink.onclick = function () {
                self.ResultsViewer.SearchBar.SetText("");
                self.SearchBar.SetDateOptionValueUI(od.searchengine.DateOption.LastMonth);
                self.SearchBar.SetSearchOptionValue(od.searchengine.SearchOption.Extended);
                self.ResultsViewer.SearchBar.StartSearch(false);
            };

            var datePickerLabel = document.createElement("div");
            datePickerLabel.innerHTML = "На дату:";
            datePickerLabel.style.marginBottom = "2px";
            datePickerLabel.style.color = "#8c96a5";
            datePickerLabel.style.fontSize = "13px";
            this.ParentControl.appendChild(datePickerLabel);

            var datePickerHolder = document.createElement("div");
            this.ParentControl.appendChild(datePickerHolder);

            this.DatePicker = new PP.Ui.DateTimePicker({
                ParentNode: datePickerHolder,
                Width: 150
            });

            var calendar = this.DatePicker.getCalendar();
            calendar.setShowDaysButton(false);
            calendar.setShowHalfYearsButton(false);
            calendar.setShowMonthsButton(false);
            calendar.setShowQuartersButton(false);
            calendar.setShowWeeksButton(false);
            calendar.setShowTime(false);
            calendar.setShowNowButton(false);

            this.DatePicker.DateTimeChanged.add(function (sender, args) {
                var calendar = sender.getCalendar();
                var month = parseInt(calendar.getCurrentMonth()) + 1;
                var monthStr = month < 10 ? "0" + month.toString() : month.toString();
                self.ResultsViewer.SearchBar.SetText("");
                self.SearchBar.SetDateOptionValueUI(calendar.getCurrentDay() + "." + monthStr + "." + calendar.getCurrentYear());
                self.SearchBar.SetSearchOptionValue(od.searchengine.SearchOption.Extended);
                self.ResultsViewer.SearchBar.StartSearch(false);                
            });
        }
    }
};

