var cookieManager = new Object();

cookieManager.set_cookie = function(name, value, date, path, domain, secure) {
    var cookie_string = name + "=" + escape(value);

    if (date) {
        cookie_string += "; expires=" + date.toGMTString();
    }

    if (path)
        cookie_string += "; path=" + escape(path);

    if (domain)
        cookie_string += "; domain=" + escape(domain);

    if (secure)
        cookie_string += "; secure";

    document.cookie = cookie_string;
};

cookieManager.delete_cookie = function(cookie_name) {
    var cookie_date = new Date(); // Текущая дата и время
    cookie_date.setTime(cookie_date.getTime() - 1);
    document.cookie = cookie_name += "=; expires=" + cookie_date.toGMTString();
};

cookieManager.get_cookie = function(cookie_name) {
    var results = document.cookie.match('(^|;) ?' + cookie_name + '=([^;]*)(;|$)');

    if (results)
        return (unescape(results[2]));
    else
        return null;
};

cookieManager.insertValueInCookieArray = function(string_array, new_value) {

    if (string_array == null || string_array == "")
        return new_value;

    string_array = unescape(string_array);

    if (new_value == null || new_value == "")
        return string_array;

    var cookie_array = string_array.split('|');

    if (cookie_array.indexOf(new_value) == -1)
        string_array = string_array + "|" + new_value;

    return string_array;
};

cookieManager.replaceValueInCookieArray = function (string_array, new_value) {

    if (string_array == null || string_array == "")
        return new_value;

    string_array = unescape(string_array);

    if (new_value == null || new_value == "")
        return string_array;

    var cookie_array = string_array.split('|');

    if (cookie_array.indexOf(new_value) > -1)
        string_array = cookieManager.deleteValueFromCookieArray(string_array, new_value);

    string_array = string_array + "|" + new_value;

    return string_array;
};

cookieManager.deleteValueFromCookieArray = function(string_array, value) {

    if (string_array == null || string_array == "")
        return null;

    string_array = unescape(string_array);

    if (value == null || value == "")
        return string_array;

    var cookie_array = string_array.split('|');

    if (cookie_array.indexOf(value) > -1) {

        string_array = "";

        for (var i = 0; i < cookie_array.length; i++) {

            if (value != cookie_array[i]) {
                if (string_array == "") {
                    string_array = cookie_array[i];
                } else {
                    string_array = string_array + "|" + cookie_array[i];
                }
            }
        }
    }
    return string_array;
};


$(function () {

   
    
});